#!/usr/bin/perl -W
#--------------------------------------------------------------
#
#    This script converts filenames given by command
#       line fileglob (e.g. *.for) to lower case
#
#     		Author: Sergey Stepanov
#
# Version-1.0:  2018/02/13
#--------------------------------------------------------------
  use strict;
# use File::Copy;				#for "move" function
# use warnings::unused;

  my ($script, $syntax, $narg, $i, @filelist, $file, $lower);

  select STDOUT; $|=1;			# set unbuffered output
  select STDERR; $|=1;			# set unbuffered output

  $script = $0 =~ s/^.*[\/\\]//gr;	#remove everything before last "/" or "\"

  $syntax   = "\n".'Syntax: '.$script.' fileglob'."\n\n";
  $narg = @ARGV;
  if ($narg == 0) {die $syntax;}

### ATTENTION: fileglob is something like: xxx.*  or aa*bb.ccc
###            to verify fileglob on Windows/DOS:  dir /b xxx.*
###            to verify fileglob on Linux/Unux:   ls -1 xxx.*
### On different platforms PERL interprets files globs in the command line differently:
### on Windows it simply passes it to the script as a single argument, while
### on UNIX the script receives a parsed list (i.e. many arguments instead of one).

  @filelist = ();
  if ($^O =~ /Win/i) {							#Windows
     for ($i=0; $i<$narg; $i++) {push @filelist, glob($ARGV[$i]);}
  } else {								#Linux
     for ($i=0; $i<$narg; $i++) {push @filelist, $ARGV[$i];}
  }

  if (!defined $filelist[0]) {
     die "\n".$script.': No files found for given fileglob.'."\n";
  }

  foreach $file (@filelist) {
     if (!(-e $file)) {
	print STDOUT "\n".'!!! '.$script.': file='.$file.' does not exist, skipping...'."\n\n";
     } else {
        $lower = lc($file);
        if ($lower ne $file) {
           print STDOUT $script.': converting "'.$file.'" -> "'.$lower.'"'."\n";
           if (! rename($file,$lower)) {
#          if (! move($file,$lower)) {
	      print STDOUT "\n".'!!! '.$script.': converting "'.$file.'" failed.'."\n\n";
	   }
        }  
     }
  }
  print STDOUT "\n".$script.': finished!'."\n\n";
