#!/usr/bin/perl -W
#--------------------------------------------------------------
# This types current detector type (marccd or pilatus)
#
#
#     		Author: Sergey Stepanov
#
# Version-1:  2014/01/30 using Pezca
#--------------------------------------------------------------
  use strict;
  use Pezca;
  use DBI;

  my ($PEZCA, $script, $serial, $name, $status);

  if    (defined $ENV{PEZCA})     {$PEZCA=$ENV{PEZCA};}
  elsif (defined $ENV{FASTSCANS}) {$PEZCA=$ENV{FASTSCANS}; $PEZCA=~s/fastscans$/pezca/i;}
  else {if ($^O !~ /Win/i) {$PEZCA='/home/gmca/epics/pezca';}else{$PEZCA='c:/gmca/pezca';}}
  $PEZCA =~ s/\\/\//g;


  do $PEZCA.'/Common/ccd_subs.pl';
  do $PEZCA.'/Common/common_subs.pl';
  do $PEZCA.'/Common/beamline.pl';

  select STDERR; $|=1;			# set unbuffered output
  select STDOUT; $|=1;			# set unbuffered output

  $script = &makeScriptName();

  ($name,$status) = &getCCDname();

  if ($status == 0) {print STDOUT 'detector='.$name."\n";}
  else              {print STDERR $script.': getCCDname returned status = '.$status."\n";}

  &clearAllCaMonitors();
  exit;
