package gov.anl.gmca.collect;

import gov.anl.gmca.common.ui.NBDlgIgnore;
import gov.anl.gmca.gui.GUI;
import gov.anl.gmca.hutch.DevPmacMotor;
import gov.anl.gmca.hutch.DevUndulator;
import gov.anl.gmca.util.Util;
import org.eclipse.swt.SWT;

public class EnergyCheckThread
{
	protected static final int MINIMUM_DELAY_SEC = 5;
	
	public static void start()
	{
		// energy gap check thread
		new Thread(new Runnable()
		{
			public void run()
			{
				final DevPmacMotor monoDev = DevPmacMotor.get("mo_En_E");
				
				int secondsToWait = MINIMUM_DELAY_SEC;
				
				while (true)
				{
					while (Util.atExit() || null == GUI.getShell())
					{
						System.out.println("At exit or shell is null, not checking energy gap.");
						Util.sleep(10000);
					}
					
    				boolean pass = CmdCheck.energyGapCheck(true);
        			if (!pass)
        			{
						String title = "Energy gap check";
						String msg =
    						"At the current energy, the undulator energy should be "+
    						Util.sprintf("%.4f",DevUndulator.calcHarmonicAndOffset(monoDev.getPosition()).get(0).offset)+
    						" keV higher than the monochromator energy.  "+
    						"Choosing a new energy in the hutch tab will re-sync both devices.";
        				
						NBDlgIgnore dialog = new NBDlgIgnore(title, msg, SWT.ICON_WARNING);
        				secondsToWait = dialog.open();
        				
        				if (secondsToWait < MINIMUM_DELAY_SEC) secondsToWait = MINIMUM_DELAY_SEC;
        				System.out.println("Sleeping "+secondsToWait+" seconds...");
        			}
        			else
        			{
        				secondsToWait = MINIMUM_DELAY_SEC;
        			}
        			
        			Util.sleep(1000 * secondsToWait);
				}
			}
		}, "Energy Check").start();
	}
}
