package gov.anl.gmca.collect.ui;

import gov.anl.gmca.common.ui.NBMessageBox;
import gov.anl.gmca.gui.GUI;
import gov.anl.gmca.util.Pair;
import gov.anl.gmca.util.Util;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.StyleRange;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Shell;

import java.util.ArrayList;

public class DlgVerifyEnergies extends NBMessageBox
{
	private ArrayList<Pair<Integer,Double>> energiesToVerify;
	public DlgVerifyEnergies(Shell parent, ArrayList<Pair<Integer,Double>> energies)
	{
		super(parent, SWT.OK|SWT.CANCEL|SWT.ICON_QUESTION);
		energiesToVerify=energies;
		setText("Verify energy move"+(energies.size()>1?"s":""));
	}
	
	@Override protected void createMessageWidget(Composite parent)
	{
		// formatted text widget
		StyledText st = new StyledText(parent, SWT.READ_ONLY);
		st.setBackground(parent.getBackground());
		st.setCaret(null);
		
		// fill text and save indices of where the energy text starts and ends
		String energyTerm = energiesToVerify.size()>1?"energies":"energy";
		String str = "JBluIce will move to the following "+energyTerm+":\n\n";
		ArrayList<StyleRange> srList = new ArrayList<>();
		for (Pair<Integer,Double> energy : energiesToVerify)
		{
			str += "Run "+energy.a+": ";
			
			// highlight for energy values
			StyleRange highlight = new StyleRange();
			highlight.foreground = GUI.COLOR_DARK_RED;
			highlight.font = GUI.FONT_14_BOLD;
			highlight.start = str.length();

			String energyStr = Util.printDouble(energy.b, 3)+" keV\n";
			str += energyStr;
			
			highlight.length = str.length()-highlight.start-1;
			srList.add(highlight);
		}
		str += "\nOK to proceed?";
		st.setText(str);
		st.setStyleRanges(srList.toArray(new StyleRange[0]));
	}
}
