package gov.anl.gmca.collect.ui;

import gov.anl.gmca.collect.ModelCollectRun;
import gov.anl.gmca.common.EpicsDevice;
import gov.anl.gmca.common.Limits;
import gov.anl.gmca.common.ui.WdgControl;
import gov.anl.gmca.common.ui.WdgControlEntry;
import gov.anl.gmca.hutch.DevPmacMotor;
import gov.anl.gmca.util.WidgetFactory;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Label;

public class WdgCenteredAngle
{
    private Label label, units;

    private WdgControlEntry entry;

    public WdgCenteredAngle(WdgCollectParams parent, ModelCollectRun run)
    {
        label = WidgetFactory.newLabel(parent, SWT.RIGHT, "Centered \u2220:"); label.setLayoutData(WdgRunTab.newGDLeftLabel());
        entry = new WdgControlEntry(parent, SWT.NONE, WdgControlEntry.EntryType.RW_COMBO,  new WdgControlEntry.ModelInterface()
        {
            @Override public void setValue(Object value)	{ run.dev().setDistance((Double)value,true);						}
            @Override public Object getModelValue() 		{ return run.getdistance_mm();										}
            @Override public EpicsDevice getDevice()		{ return DevPmacMotor.get("detector_z");							}
            @Override public Object getDeviceValue() 		{ return DevPmacMotor.get("detector_z").getPosition(); 				}
            @Override public Limits getLimits() 			{ return DevPmacMotor.get("detector_z").getLimits(); 				}
            @Override public int getDecimals() 				{ return 2; 														}
            @Override public double[] getFloatChoices()		{ return new double[]{1.0,2.0,5.0,10.0,20.0};						}
            @Override public boolean doHighlight(double d)  { return Math.abs((Double)getDeviceValue()-d)>0.01; }
        });
        entry.setLayoutData(WdgRunTab.newGDEntry());
        units = WidgetFactory.newLabel(parent, SWT.LEFT, "degr"); units.setLayoutData(WdgRunTab.newGDRightLabel());
    }
    public void setEnabled(boolean _enable) {entry.setEnabled(_enable);}
    protected void runChanged() {}
    public boolean updateModel() { return true; }

    public void setVisible(boolean visible)
    {
        WdgControl.setControlVisible(label, visible);
        WdgControl.setControlVisible(entry, visible);
        WdgControl.setControlVisible(units, visible);
    }
}
