package gov.anl.gmca.collect.ui;

import gov.anl.gmca.collect.DevFPE;
import gov.anl.gmca.collect.DevFPE.FPEState;
import gov.anl.gmca.collect.DevFPE2;
import gov.anl.gmca.gui.GUI;
import gov.anl.gmca.util.ListenerList;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;

public class WdgFPEStatus extends Composite
{
	private Label lblDesc;
	
	public WdgFPEStatus(Composite parent)
	{
		super(parent, SWT.NONE);
		setLayout(new FillLayout());
		setBackground(GUI.BGCOLOR);
		
		Group group = new Group(this, SWT.NONE);
		group.setText("Collect State");
		group.setFont(GUI.FONT_COLLECT_GROUP);
		GridLayout gl = new GridLayout(1,false);
		gl.verticalSpacing=2;
		group.setLayout(gl);
		group.setBackground(GUI.BGCOLOR);
		
		lblDesc = new Label(group, SWT.LEFT);
		lblDesc.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		lblDesc.setFont(GUI.FONT_10);
		lblDesc.setBackground(GUI.BGCOLOR);
		
		connectListeners();
	}
	
	private void connectListeners()
	{
		DevFPE2.get().llFPEState.addListener(new ListenerList.Listener<DevFPE>()
		{
			@Override public void handleEvent(DevFPE object, Object data)
			{
				updateState();
			}
		});
		updateState();
	}
	
	private void updateState()
	{
		GUI.asyncExec(new Runnable(){public void run()
		{
			FPEState state = DevFPE.get().getFPEState();
			if (null==state)
			{
				String msg = "FPE is off.\n" +
					  "Please try running \"restart_fpe\" in a terminal.\n" +
					  "If needed, staff may run \"fpe\" to view the FPE console.";
				lblDesc.setText(msg);
				lblDesc.setForeground(GUI.COLOR_DARK_RED);
				lblDesc.setBackground(GUI.COLOR_LIGHT_RED);
				return;
			}

			// text display
			lblDesc.setForeground(GUI.COLOR_BLACK);
			lblDesc.setBackground(GUI.BGCOLOR);
			switch (state)
			{
			case idle:
				lblDesc.setText("Ready to collect");
				break;
			default:
				lblDesc.setText("FPE is busy");
				break;
			}
		}});
	}
}
