package gov.anl.gmca.collect.ui;

import gov.anl.gmca.collect.ModelCollectRun;
import gov.anl.gmca.common.ui.NBFileDialog;
import gov.anl.gmca.gui.GUI;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Text;

public class WdgFileImport extends Composite implements ModelCollectRun.Listener
{
	private ModelCollectRun run;
	private Button button;
	private Text path;
	
	public WdgFileImport(Composite parent, ModelCollectRun run)
	{
		super(parent, SWT.NONE);
		this.run=run;
		setBackground(GUI.BGCOLOR);
		
		GridLayout gl = new GridLayout(2,false);
		setLayout(gl);
		
		button = new Button(this, SWT.PUSH);
		button.setText("Open");
		button.setLayoutData(new GridData());
		button.addSelectionListener(new SelectionListener()
		{
			@Override public void widgetSelected(SelectionEvent e) {
				NBFileDialog fd = new NBFileDialog(GUI.getShell(), SWT.NONE);
				fd.setFilterPath(System.getProperty("user.home"));
				fd.setFilterExtensions(new String[] { "*.*" });
				String ret = fd.openStr();
				if (null!=ret)
				{
					run.dev().setImportPath(ret, true);
				}
			}
			@Override public void widgetDefaultSelected(SelectionEvent e) {}
		});
		
		path = new Text(this, SWT.BORDER | SWT.READ_ONLY);
		path.setBackground(GUI.COLOR_LIGHT_GRAY);
		GridData gd = new GridData(SWT.FILL, SWT.DEFAULT, true, false);
		path.setLayoutData(gd);
		
		run.addListener(this);
	}

	@Override public void runChanged(ModelCollectRun run)
	{
		GUI.asyncExec(new Runnable(){public void run() {
			String pathString = run.getImportPath();
			String homeDir = System.getProperty("user.home");
			if (pathString.indexOf(homeDir)==0)
			{
				pathString = "~"+pathString.substring(homeDir.length());
			}
			path.setText(pathString);
			path.setSelection(pathString.length());
			path.setToolTipText(pathString);
		}});
	}
	
	public void setEnabled(boolean enable)
	{
		button.setEnabled(enable);
	}
}
