package gov.anl.gmca.collect.ui;

import gov.anl.gmca.collect.ModelCollectRun;
import gov.anl.gmca.gui.GUI;
import gov.anl.gmca.raster.ModelRasterSiteList.Site;
import gov.anl.gmca.raster.ui.WdgRasterSiteList;
import gov.anl.gmca.raster.ui.WdgRasterSiteList.ListType;
import gov.anl.gmca.util.ListenerList.Listener;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.TableItem;

public class WdgRasterAllSites extends Composite
{
	protected static final Object[][] headers =
	{
		{"Selection",		95},
		{"Source",			65},
		{"Size (\u03BCm)",	85}
	};
	
	private ModelCollectRun run;
	private boolean widgetEnabled = false;
	private WdgRasterSiteList wdgSiteList;
	
	public WdgRasterAllSites(Composite parent, ModelCollectRun run)
	{
		super(parent, SWT.BORDER);
		this.run=run;
		
		createWidgets();
	}
	
	protected void createWidgets()
	{
		setBackground(GUI.COLOR_DARK_GRAY5);

		GridLayout gl = new GridLayout(1,false);
		gl.marginWidth=0;
		gl.marginHeight=0;
		gl.horizontalSpacing=0;
		gl.verticalSpacing=1;
		setLayout(gl);

		Label titleLabel = new Label(this, SWT.CENTER);
		titleLabel.setLayoutData(new GridData(SWT.FILL, SWT.DEFAULT, true, false));
		titleLabel.setFont(GUI.FONT_DEFAULT);
		titleLabel.setText("Available Sites");
		
		wdgSiteList = new WdgRasterSiteList(this, SWT.NONE, headers, ListType.COLLECT_LIST, run);
		wdgSiteList.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));
		wdgSiteList.llButtonClicked.addListener(new Listener<WdgRasterSiteList>()
		{
			@Override public void handleEvent(WdgRasterSiteList object, Object data)
			{
				Site site = (Site)data;
				run.dev().setSiteSelected(site.index, true, true);
			}
		});
		wdgSiteList.getTable().addMouseListener(new MouseListener()
		{
			@Override public void mouseUp(MouseEvent me) {}
			@Override public void mouseDown(MouseEvent me) {}
			@Override public void mouseDoubleClick(MouseEvent arg0)
			{
				// move to site on double-click
				TableItem selected[] = wdgSiteList.getTable().getSelection();
				if (selected.length==0) return;
				TableItem item = selected[0];
				Site site = (Site)item.getData();
				
				run.moveToRasterSite(site);
			}
		});
	}
	
	@Override public void setEnabled(boolean enable)
	{
		wdgSiteList.setEnabled(enable);
	}
	
	public void updateSelected()
	{
		
	}
}
