package gov.anl.gmca.collect.viewer;

import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseListener;
import org.eclipse.swt.events.MouseMoveListener;

public class ListenerPan implements MouseListener, MouseMoveListener
{
	private WdgDiffViewer viewer;
	boolean inPanDrag = false;
	private int dragStartX=0, dragStartY=0;
	private double dragStartPctX=0, dragStartPctY=0;
	
	public ListenerPan(WdgDiffViewer viewer)
	{
		this.viewer = viewer;
		
		viewer.addMouseListener(this);
		viewer.addMouseMoveListener(this);
	}
	
	@Override public void mouseDown(MouseEvent e)
	{
		if (e.button==1 || e.button==2) // 1 is left button, 2 is middle button
		{
			inPanDrag=true;
			dragStartX=e.x;
			dragStartY=e.y;
			dragStartPctX=viewer.model._percentX;
			dragStartPctY=viewer.model._percentY;
		}
	}

	@Override public void mouseUp(MouseEvent e)
	{
		inPanDrag=false;
	}

	@Override public void mouseMove(MouseEvent e)
	{
		if (inPanDrag)
		{
			int canvasHeight = viewer.model.imgHeight - viewer.model.titleHeight;
			
			int dx = e.x-dragStartX;
			int dy = e.y-dragStartY;
			
			double xDragPercent = ( (double)dx / (double)viewer.model.imgWidth) / viewer.model.getZoom();
			double yDragPercent = ( (double)dy / (double)canvasHeight) / viewer.model.getZoom();

			viewer.model._percentX = dragStartPctX-xDragPercent;
			viewer.model._percentY = dragStartPctY-yDragPercent;
			
			viewer.model.requestUpdate();
		}
	}
	
	@Override public void mouseDoubleClick(MouseEvent arg0) {}
}
