package gov.anl.gmca.common;

import gov.anl.gmca.raster.ModelRasterRun;
import gov.anl.gmca.sample.DevCollimatorCtrl;
import gov.anl.gmca.scan.ModelScan;
import gov.anl.gmca.spotfinder.SFData;

import java.sql.Timestamp;

public enum SQLDataType
{
	FLOAT, INT, AUTOINC, STRING, BOOL, TIMESTAMP, VARCHAR,
	
	ENUM_RASTER_TYPE	(ModelRasterRun.RunType.values()),
	ENUM_SEARCH_TYPE	(ModelRasterRun.RefinementType.values()),
	ENUM_COLLIMATOR		(DevCollimatorCtrl.CollimatorSize.values()),
	ENUM_ROI_TYPE		(ModelRasterRun.ROIMode.values()),
	ENUM_AUTOSCAN_STEP	(ModelScan.AutoStep.values()),
	ENUM_INTERSCAN_STEP	(ModelScan.InterStep.values()),
	ENUM_RUN_TYPE		(ModelRunList.RunType.values()),
	ENUM_PROCESS_STATE	(SFData.State.values());
	
	public String[] values;
	private SQLDataType(){}
	private SQLDataType(String[] values){this.values=values;}
	private SQLDataType(Object[] values)
	{
		this.values=new String[values.length];
		for (int i=0; i<values.length; i++)
		{
			this.values[i] = values[i].toString();
		}
	}
	public static String getCurrentTimeString()
	{
		java.util.Date now = new java.util.Date();
		Timestamp tsNow = new Timestamp(now.getTime());
		return tsNow.toString();
	}
}
