package gov.anl.gmca.common;

public class ValidateDirPrefix
{
	final static String validFileChars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890-_";
	final static String validDirChars = validFileChars+"/";
	
	public static String validateFileName(String filename)	{ return validate(validFileChars,filename); }
	public static String validateDir(String dir)			{ return validate(validDirChars,dir);		}
	
	private static String validate(String validChars, String n)
	{
		for (int i = 0; i < n.length(); i++) {
			if (validChars.indexOf(n.charAt(i)) < 0)
				n = n.replace(Character.toString(n.charAt(i)), "_");
		}
		return n;
	}

	public static boolean isValidFullFilename(String filename)
	{
		int lastDotIndex = filename.lastIndexOf('.');
		
		// starts with a dot?
		if (lastDotIndex==0) return false;
		
		// ends with a dot?
		if (lastDotIndex==filename.length()-1) return false;
		
		// not at least one char on each side of the dot?
		if (filename.length()<3) return false;
		
		// more than one dot?
		if (filename.substring(0, lastDotIndex).contains(".")) return false;
		
		// chars before the dot valid?
		if (!isValidFilename(filename.substring(0,lastDotIndex))) return false;
		
		// chars after the dot valid?
		if (!isValidFilename(filename.substring(lastDotIndex+1,filename.length()))) return false;
		
		// filename is OK
		return true;
	}
	public static boolean isValidFilename(String filename)	{ return isValid(validFileChars,filename);	}
	public static boolean isValidDir(String filename)		{ return isValid(validDirChars,filename);	}
	
	private static boolean isValid(String validChars, String dir)
	{
		for (int i=0;i<dir.length();i++)
		{
			if (validChars.indexOf(dir.charAt(i))==-1) return false;
		}
		return true;
	}
}
