package gov.anl.gmca.common.client_server;

import com.google.common.collect.ArrayListMultimap;
import com.google.common.collect.ListMultimap;
import gov.anl.gmca.io.hw.Epics;

public class StateEvents
{
	public interface StateListener
	{
		public abstract void stateChanged(String key, String value);
	}
	private static ListMultimap<String,StateListener> listenerMap = ArrayListMultimap.create();
	
	public static void addListener(String key, StateListener listener)
	{
		synchronized(listenerMap) {
			listenerMap.put(key, listener);
		}
		callListeners(key, StateMap.getKey(StateMap.currentMap, key));
	}
	
	public static void callListeners(String key, String value)
	{
		synchronized(listenerMap)
		{
			for (StateListener listener : listenerMap.get(key))
			{
				Epics.executor.submit(()-> listener.stateChanged(key, value));
			}
		}
	}
}
