package gov.anl.gmca.common.client_server.ui;

import gov.anl.gmca.gui.GUI;
import gov.anl.gmca.syslog.WdgLog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

public abstract class DlgJSONView
{
    protected boolean isShellOpen() { return null!=dialogShell && !dialogShell.isDisposed(); }

    public void jsonChange(String s)
    {
        GUI.asyncExec(()->{if (isShellOpen()) jsonText.setText(WdgLog.currentTimestamp(true)+"\n"+s);});
    }
    public void statusChange(String s)
    {
        GUI.asyncExec(()->{if (isShellOpen()) updateText.append(WdgLog.currentTimestamp(true)+" "+s+"\n");});
    }
    public void cmdSent(String s)
    {
        GUI.asyncExec(()->{if (isShellOpen()) cmdText.append(WdgLog.currentTimestamp(true)+" "+s+"\n");});
    }
    public void cmdReceived(String s)
    {
        GUI.asyncExec(()->{if (isShellOpen()) cmdText.append(WdgLog.currentTimestamp(true)+" "+s+"\n");});
    }

    /////////////////////////////////////////////////////////////////////////////////////////

    protected Shell dialogShell;
    protected Text jsonText, cmdText, updateText;
    protected String title;

    public void open()
    {
        GUI.asyncExec(()->
        {
            dialogShell = new Shell(GUI.getShell(), SWT.SHELL_TRIM);
            dialogShell.setText(title);
            dialogShell.setLayout(new GridLayout(2, false));

            jsonText = new Text(dialogShell, SWT.MULTI | SWT.V_SCROLL | SWT.READ_ONLY | SWT.WRAP);
            jsonText.setFont(GUI.FONT_9_FIXED);
            GridData gd = new GridData(SWT.FILL, SWT.FILL, true, true);
            gd.widthHint = 400;
            gd.heightHint = 400;
            jsonText.setLayoutData(gd);
            jsonText.setText("-- JSON --\n");

            cmdText = new Text(dialogShell, SWT.MULTI | SWT.V_SCROLL | SWT.READ_ONLY | SWT.WRAP);
            cmdText.setFont(GUI.FONT_9_FIXED);
            gd = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 2);
            gd.widthHint = 400;
            gd.heightHint = 600;
            cmdText.setLayoutData(gd);
            cmdText.setText("-- Commands --\n");

            updateText = new Text(dialogShell, SWT.MULTI | SWT.V_SCROLL | SWT.READ_ONLY | SWT.WRAP);
            updateText.setFont(GUI.FONT_9_FIXED);
            gd = new GridData(SWT.FILL, SWT.FILL, true, true);
            gd.widthHint = 400;
            gd.heightHint = 200;
            updateText.setLayoutData(gd);
            updateText.setText("-- Updates --\n");

            dialogShell.pack();
            dialogShell.open();

            /*dialogShell.addTraverseListener(new TraverseListener()
            {
                @Override public void keyTraversed(TraverseEvent te)
                {
                    if (te.detail == SWT.TRAVERSE_ESCAPE)
                    {
                        closedOnEscape = true;
                        te.doit = true;
                    }
                }
            });*/
        });
    }

    public void close()
    {
        dialogShell.dispose();
    }
}
