package gov.anl.gmca.common.ui;

import gov.anl.gmca.gui.GUI;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;

public class WdgControlCheckbox extends WdgControl implements SelectionListener
{
	protected Button checkbox;
	
	public WdgControlCheckbox(Composite parent, int style, ModelInterface mi)
	{
		super(parent, style, mi);
		setLayout(new FillLayout());
		
		checkbox = new Button(this,SWT.CHECK);
		checkbox.setEnabled(false);
		checkbox.setFont(GUI.FONT_DEFAULT);
		checkbox.setBackground(parent.getBackground());
		checkbox.addSelectionListener(this);
	}
	
	@Override
	public void setEnabled(boolean enabled)
	{
		checkbox.setEnabled(enabled);
	}
	
	public void setSelected(boolean selected)
	{
		checkbox.setSelection(selected);
	}

	// send to device
	@Override
	public void widgetSelected(SelectionEvent e)
	{
		mi.setValue(checkbox.getSelection());
	}
	
	@Override public void widgetDefaultSelected(SelectionEvent e) {}

	@Override
	public boolean updateModel()
	{
		return true;
	}
}
