package gov.anl.gmca.common.ui;

import gov.anl.gmca.gui.GUI;
import gov.anl.gmca.io.Epics;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.*;

public class WdgEpicsState
{
	protected static Shell shell;

	public static void open()
	{
		shell = new Shell(GUI.getShell(), SWT.RESIZE);
		shell.setText("EPICS state");
		shell.setLayout(new GridLayout(1,false));
		shell.setSize(800, 600);
		
		Label label = new Label(shell, SWT.LEFT);
		label.setText("Total PVs: "+Epics.getAllPVNames().length);
		label.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		
		Table table = new Table(shell, SWT.NONE);
		table.setLayoutData(new GridData(GridData.FILL_BOTH));
		
		TableColumn nameCol = new TableColumn(table, SWT.LEFT);
		nameCol.setText("PV Name");
		nameCol.setWidth(300);

		TableColumn valCol = new TableColumn(table, SWT.CENTER);
		valCol.setText("Value");
		valCol.setWidth(200);

		table.setHeaderVisible(true);
		
		for (String pvName : Epics.getAllPVNames())
		{
			TableItem item = new TableItem(table, SWT.NONE);
			item.setText(new String[]{pvName,Epics.pvs_getString(pvName)});
		}
		
		shell.pack();
		shell.open();
	}
}
