package gov.anl.gmca.common.ui;

import gov.anl.gmca.gui.GUI;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.*;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Event;

import java.util.ArrayList;

public class WdgMaximize extends Composite
{
	private PaintListener paintListener;
	private MouseListener mouseListener;
	private MouseTrackListener mouseTrackListener;
	private ArrayList<SelectionListener> slList = new ArrayList<SelectionListener>();
	public void addSelectionListener(SelectionListener sl) { slList.add(sl); }
	
	public WdgMaximize(Composite parent, int style)
	{
		super(parent, SWT.NONE);
		
		paintListener = new PaintListener()
		{
			@Override public void paintControl(PaintEvent pe)
			{
				draw(pe.gc);
			}
		};
		addPaintListener(paintListener);
		
		mouseListener = new MouseListener()
		{
			@Override public void mouseDoubleClick(MouseEvent arg0) {}
			@Override public void mouseUp(MouseEvent arg0) {}
			@Override public void mouseDown(MouseEvent me)
			{
				if (me.button==1) handleMouseDown();
			}
		};
		addMouseListener(mouseListener);
		
		mouseTrackListener = new MouseTrackListener()
		{
			@Override public void mouseEnter(MouseEvent arg0)
			{
				handleMouseEnter();
			}
			@Override public void mouseExit(MouseEvent arg0)
			{
				handleMouseExit();
			}
			@Override public void mouseHover(MouseEvent arg0) {}
		};
		addMouseTrackListener(mouseTrackListener);
	}
	
	private void handleMouseEnter()
	{
		
	}
	
	private void handleMouseExit()
	{
		
	}
	
	private void handleMouseDown()
	{
		for (SelectionListener sl : slList)
		{
			Event event = new Event();
			event.widget = this;
			SelectionEvent se = new SelectionEvent(event);
			sl.widgetSelected(se);
		}
	}
	
	private void draw(GC gc)
	{
		gc.setForeground(GUI.COLOR_DARK_GRAY3);
		gc.setBackground(GUI.COLOR_DARK_GRAY3);
		gc.drawRectangle(0,4,11,11);
		gc.fillRectangle(0,4,11,3);
	}
	
	@Override public Point computeSize(int wHint, int hHint)
	{
		return getSize();
	}
	
	@Override public Point computeSize(int wHint, int hHint, boolean changed)
	{
		return getSize();
	}
	
	@Override public Point getSize()
	{
		return new Point(18,18);
	}
}
