package gov.anl.gmca.common.ui;

import gov.anl.gmca.util.VerticalText;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseTrackListener;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.widgets.Composite;

public class WdgRotatedLabel extends Composite implements PaintListener, MouseTrackListener
{
	private boolean mouseHover = false;
	
	private String text = "";
	public void setText(String text) { this.text=text; redraw(); }
	
	public WdgRotatedLabel(Composite parent, int style)
	{
		super(parent, style);
		addPaintListener(this);
		addMouseTrackListener(this);
	}

	@Override public void paintControl(PaintEvent e)
	{
		String fullText = mouseHover ? text+"   vv" : text;
		VerticalText.drawString(e.gc, fullText, 18, 0, SWT.RIGHT, null);
	}

	@Override public void mouseEnter(MouseEvent e)
	{
		mouseHover=true;
		redraw();
	}

	@Override public void mouseExit(MouseEvent e)
	{
		mouseHover=false;
		redraw();
	}

	@Override public void mouseHover(MouseEvent e)
	{
		
	}
}