/**
 * @author spothineni
 * 
 * This class is cache for all the dataprocessing results 
 * dipalyed on the Data quality sub-tab of Analysis tab
 * It also has functions for deleting/saving the data porcessing results
 */

package gov.anl.gmca.dataproc;

import gov.anl.gmca.util.ListenerList;
import gov.anl.gmca.util.Util;

import java.util.ArrayList;
import java.util.Collections;

public class ModelDataProcList {

	public ListenerList<ModelDataProcList> ll;
	
	/* cache */
	protected ArrayList<ModelDataProc> resultList = new ArrayList<ModelDataProc>();
	
	public static String currentSoftwareSelection = "fast_dp";

	public ArrayList<ModelDataProc> getDataProcList() {
		return new ArrayList<ModelDataProc>(resultList);
	}

	public ModelDataProc getResultID(int requestedID) {
		for (ModelDataProc result : getDataProcList()) {
			if (result.getID() == requestedID)
				return result;
		}
		return null;
	}

	public ModelDataProc getResultIndex(int index) {
		try {
			return resultList.get(index);
		} catch (IndexOutOfBoundsException ioobe) {
			return null;
		}
	}

	public ModelDataProc getCurrentResult() {
		return getResultIndex(getCurrentDataProcIndex());
	}

	public void clearResults() {
		resultList = new ArrayList<ModelDataProc>();
	}

	public void setRow(ModelDataProc result, int sampleNo, boolean update) {
		for (int i = 0; i < resultList.size(); i++) {
			if (resultList.get(i).getID() != null) {
				if (resultList.get(i).getID() == sampleNo) {
					resultList.set(i, result);
					return;
				}
			} else
				return;
		}

		resultList.add(result);

		Collections.sort(resultList);

		if (update)
			ll.notifyListeners(result.getID());
	}

	protected int currentDataProcIndex = 0;

	public void setCurrentDataProcIndex(int i) {
		currentDataProcIndex = i;
	}

	public int getCurrentDataProcIndex() {
		return currentDataProcIndex;
	}

	protected static ModelDataProcList inst = null;

	public static ModelDataProcList get() {
		return inst;
	}

	public ModelDataProcList() {
		inst = this;
		ll = new ListenerList<ModelDataProcList>(this);
	}
	/**
	 * This function deletes all the porcessing results
	 * it is accessible for the user from Options popup
	 */
	public void deleteAll() {
		new Thread(new Runnable() {
			public void run() {
				boolean okToDelete = Util.popupOkCancel(
						"Delete?",
						"OK to delete ALL ("
								+ resultList.size()
								+ ") strategy results?  This action cannot be undone.");
				if (okToDelete)
					DevDataProc.get().deleteAllResults();
			}
		}).start();
	}
	
	/**
	 * saves the data processing results into a excel spreadsheet
	 * @param excelname
	 */
	public void save(String excelname) {
		final String excelFile = excelname;
		new Thread(new Runnable() {
			public void run() {
				DevDataProc.get().saveAllResults(excelFile);
			}
		}).start();

	}
}
