package gov.anl.gmca.diffimage;

import java.awt.image.WritableRaster;

public class DiffractionImage32Bit extends DiffractionImage
{
	public int[] originalImg;
	public int originalImgWidth, originalImgHeight;
	
	@Override public boolean hasValidImage() { return null != originalImg; }
	@Override public int origWidth() { return originalImgWidth; }
	@Override public int origHeight() { return originalImgHeight; }
	
	@Override public void setContrast(double gray)
	{
		if (this.gray==gray) return;
		this.gray=gray;
		
		createContrastImage();
		
		WritableRaster raster = contrastImg.getRaster();
		for (int x=0;x<origWidth();x++)
		{
			for (int y=0;y<origHeight();y++)
			{
				int origVal = originalImg[x*originalImgHeight+y];
				int contrastVal = (int)(65535f - 10000f * (float)origVal);
				raster.setPixel(x, y, new int[]{contrastVal});
			}
		}
	}
}
