package gov.anl.gmca.gui;

import gov.anl.gmca.util.Util;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.*;

public class WdgAbout extends Dialog
{
	protected Shell dialog = null;
	
	public WdgAbout(Shell parent, int style)
	{
		super(parent, style);
	}

	public void open()
	{
		Shell parent = getParent();
		dialog = new Shell(parent, SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL);
		dialog.setText("About");

        GridLayout gl = new GridLayout(1,false);
        dialog.setLayout(gl);
        
        Label logo = new Label(dialog, SWT.BORDER);
        logo.setImage(GUI.IMAGE_LOGO);
        logo.setSize(150, 200);
        GridData gd = new GridData(SWT.DEFAULT, SWT.DEFAULT, false, false);
        gd.verticalSpan=2;
        logo.setLayoutData(gd);
    	
        Label text = new Label(dialog, SWT.BORDER|SWT.CENTER);
        text.setText("JBluIce-EPICS\n"+Util.getVersionString());
        text.setBackground(GUI.COLOR_WHITE);
        gd = new GridData(SWT.FILL, SWT.DEFAULT, true, false);
        text.setLayoutData(gd);
        
        Button okButton = new Button(dialog, SWT.PUSH);
        okButton.setText("   OK   ");
        gd = new GridData(SWT.CENTER, SWT.DEFAULT, false, false);
        okButton.setLayoutData(gd);
        okButton.addSelectionListener(new SelectionListener()
        {
			public void widgetDefaultSelected(SelectionEvent arg0) {}
			public void widgetSelected(SelectionEvent arg0)
			{
				dialog.dispose();
			}
		});
        
        dialog.setDefaultButton(okButton);
        dialog.setSize(400,200);
        dialog.pack();
        dialog.open();
        
        Display display = parent.getDisplay();
		while (!dialog.isDisposed()) {
			if (!display.readAndDispatch()) display.sleep();
		}
	}}
