package gov.anl.gmca.gui;

import gov.anl.gmca.collect.DevCollectSettings;
import gov.anl.gmca.common.ui.WdgControl;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;

public class WdgChecksWarning extends Composite
{
    private Label label;

    public WdgChecksWarning(Composite parent)
    {
        super(parent, SWT.NONE);
        setLayout(new FillLayout());

        label = new Label(this, SWT.CENTER);
        label.setBackground(GUI.COLOR_CHECKS);
        label.setForeground(GUI.COLOR_DARK_GRAY);
        label.setText("Checks disabled:");
        GridData gd = new GridData(GridData.FILL_HORIZONTAL);
        setLayoutData(gd);
        WdgControl.setControlVisible(this, false);

        DevCollectSettings.llChecks.addListener((object,data)->GUI.asyncExec(()->update()));
        GUI.asyncExec(()->update());
    }

    private String lastText = null;
    private Boolean lastShow = null;
    public void update()
    {
        String text = "";
        if (!DevCollectSettings.getEndstationCheckEnabled()) text += "ENDSTATION / ";
        if (!DevCollectSettings.getEnergyGapCheckEnabled())  text += "UND_OFFSET / ";
        if (!DevCollectSettings.getFeedbackCheckEnabled())   text += "FEEDBACK / ";
        if (!DevCollectSettings.getEnableEnergyMove())       text += "MONO_POSITION / ";
        if (!DevCollectSettings.getEnableDetectorMove())     text += "DETECTOR_DIST / ";
        if (!DevCollectSettings.getEnableSampleEnvMove())    text += "SAMPLE_ENV / ";
        if (!DevCollectSettings.getEnableCryojetMonitor())   text += "CRYOJET / ";
        if (text.length()>0) text=text.substring(0,text.length()-2);

        if (null!=lastText && text.equals(lastText)) return;
        label.setText(" Checks disabled: "+text);
        lastText = text;

        Boolean show = text.length()>0;
        if (lastShow==show) return;
        if (show) {
            GUI.shell.setSize(GUI.shell.getSize().x, GUI.shell.getSize().y + 20);
        } else if (!show && lastShow==true){
            GUI.shell.setSize(GUI.shell.getSize().x, GUI.shell.getSize().y - 20);
        }
        lastShow=show;

        WdgControl.setControlVisible(this, show);
        GUI.shell.layout(true);
    }
}
