package gov.anl.gmca.hutch;

import gov.anl.gmca.common.EpicsDevice;
import gov.anl.gmca.io.Epics;
import gov.anl.gmca.io.PVLookup.PV_KEITHLEY;
import gov.aps.jca.dbr.DBR;

public class DevKeithleyAmp extends EpicsDevice
{
	public static enum KeithleyState { IDLE, SETTING, ABORTING };
	public static enum KeithleyGain { E03, E04, E05, E06, E07, E08, E09, E10 };
	
	public DevKeithleyAmp()
	{
		super("keithley_amp");
	}
	
	public static DevKeithleyAmp get() { return (DevKeithleyAmp)getDevice("keithley_amp"); }

	public KeithleyState getKeithleyState()
	{
		return KeithleyState.values()[Epics.getInteger(PV_KEITHLEY.Set)];
	}
	
	public KeithleyGain getGain(int index)
	{
		return KeithleyGain.values()[Epics.getInteger(PV_KEITHLEY.ActGain.index(index))];
	}
	
	public void setGain(int index, KeithleyGain gain)
	{
		Epics.putInteger(PV_KEITHLEY.ActGain.index(index), gain.ordinal());
	}
	
	@Override protected void onAllPVsConnected() {}
	@Override protected void valueChangedAction(String pvName, DBR value) {}
	@Override public void abort() {}
}
