package gov.anl.gmca.hutch;

import gov.anl.gmca.common.Limits;
import gov.anl.gmca.util.Util;

import java.util.LinkedList;

public class ModelPmacMotor
{
	public static double[] getDetectorDistanceOptions()
	{
		double[] choices = {150,200,250,300,350,400,450,500,550,600,650,700,750,800,850,900,950,1000};
		DevPmacMotor detector = DevPmacMotor.get("detector_z");
		Limits limits = detector.getLimits();
		LinkedList<Double> ret = new LinkedList<>();
		for (double c : choices)
		{
			if (limits.testValue(c).isOK()) ret.add(c);
		}
		if (ret.size()>0) {
			double firstChoice = ret.get(0);
			double diff = firstChoice - limits.getLower();
			if (diff > detector.inPosBand) {
				ret.add(0, limits.getLower());
			}
		}
			
		return Util.toPrimitiveArray(ret);
	}
}
