package gov.anl.gmca.hutch;

import gov.anl.gmca.collect.DevFPE;
import gov.anl.gmca.collect.ModelCollectRunList;
import gov.anl.gmca.collect.ModelCollectRunList.CollectState;
import gov.anl.gmca.common.DevMoveFloat;
import gov.anl.gmca.gui.GUI;
import gov.anl.gmca.syslog.Log;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;

public class WdgMotorMenu extends Composite
{
	private DevMoveFloat dev;
	private Button button;
	private Menu menu;
	
	public WdgMotorMenu(Composite parent, DevMoveFloat dev)
	{
		super(parent, SWT.NONE);
		this.dev = dev;
		setLayout(new FillLayout());
		
		button = new Button(this, SWT.ARROW | SWT.DOWN);
		button.setFont(GUI.FONT_MOTOR_BUTTON);
		button.setEnabled(false);
		button.setBackground(GUI.COLOR_BLUE_BUTTON);
		button.addSelectionListener(new SelectionListener()
		{
			@Override public void widgetDefaultSelected(SelectionEvent se) {}
			@Override public void widgetSelected(SelectionEvent e)
			{
                Point screenPt = button.toDisplay(e.x, e.y);
                menu.setLocation(screenPt.x, screenPt.y+button.getSize().y);
				menu.setVisible(!menu.getVisible());
			}
		});
		
		menu = new Menu(button);
	    
		final MenuItem abortItem = new MenuItem(menu, SWT.NONE);
		abortItem.setText("Abort motion");
		abortItem.addSelectionListener(new SelectionListener()
	    {
			@Override public void widgetSelected(SelectionEvent e)
			{
				abort();
			}
			@Override public void widgetDefaultSelected(SelectionEvent e) {}
		});
	}
	
	private void abort()
	{
		if (CollectState.INACTIVE != ModelCollectRunList.get().getCollectState())
		{
			Log.note("Sending FPE abort on "+dev.getDeviceName()+" motor abort click");
			DevFPE.get().abort();
		}
		
		Log.note("Aborting motion for device: "+dev.getDeviceName());
		dev.abort();
	}
	
	@Override public void setEnabled(boolean enable)
	{
		button.setEnabled(enable);
	}
}
