package gov.anl.gmca.io;

import gov.anl.gmca.gui.Main;

import java.io.*;

// This class retrieves files that are part of the JBluIce distribution.
// Examples are image files and configuration files.
// They should all be read-only.
//
// There are no hw/sim versions of this class because the loading method doesn't
// depend on that.  Instead, it depends on whether JBluIce is run from a JAR or not.
// That is detected in this class.
//
public class Resources
{
	public static Resources get() { if (null==inst) inst=new Resources(); return inst; }
	public static Resources inst = null;

	// generic convenience method
	public BufferedReader getReader(String res)
	{
		return new BufferedReader(new InputStreamReader(getInputStream(res)));
	}
	
	public InputStream getInputStream(String filename)
	{
		String resString = getClass().getResource("Resources.class").toString();
		boolean inJar = (resString.indexOf("jar:")==0);
		
		if (inJar)
		{
			return getClass().getResourceAsStream("/"+filename);
		}
		else
		{
			try
			{
				return new FileInputStream(Main.getAppDir()+"/"+filename);
			}
			catch (FileNotFoundException e)
			{
				e.printStackTrace();
				return null;
			}
		}
	}
}
