package gov.anl.gmca.io.sim;

import java.nio.file.Path;
import java.nio.file.attribute.GroupPrincipal;
import java.nio.file.attribute.PosixFileAttributes;
import java.nio.file.attribute.UserPrincipal;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.GregorianCalendar;
import java.util.StringTokenizer;

public class Disk extends gov.anl.gmca.io.Disk
{
	private static class FileNode
	{
		private String name;
		private byte[] data;
		public FileNode(String name) { this.name=name; }
	}
	
	private static class DirNode
	{
		private String name;
		private DirNode parent;
		private ArrayList<FileNode> files = new ArrayList<FileNode>();
		
		public DirNode(String name, DirNode parent) { this.name=name; this.parent=parent;}
		
	}
	private DirNode root = new DirNode("", null);

	//////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////// implementation /////////////////////////////////
	//////////////////////////////////////////////////////////////////////////////////////////
	
	private FileNode getFileNode(String path)
	{
		return null;
	}
	
	private DirNode getDirNode(String path)
	{
		return null;
	}
	
	private ArrayList<String> parsePath(String path)
	{
		StringTokenizer st = new StringTokenizer(path,"/");
		ArrayList<String> ret = new ArrayList<String>();
		
		while (st.hasMoreTokens()) ret.add(st.nextToken());
		
		return ret;
	}
	
	private ArrayList<String> parseDirs(String path)
	{
		return null;
	}
	
	private String parseFilename(String path)
	{
		return null;
	}
	
	//////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////// public methods /////////////////////////////////
	//////////////////////////////////////////////////////////////////////////////////////////
	
	public Disk()
	{
		i_mkdirs(System.getProperty("user.home"));
	}
	
	@Override protected boolean i_copyFile(String src, String dest)
	{
		return true;
	}
	
	@Override protected String[] i_getDir(String path)
	{
		DirNode dir = getDirNode(path);
		if (null == dir) return null;
		return dir.files.toArray(new String[]{});
	}

	@Override protected boolean i_isDirectory(String path)
	{
		return null != getDirNode(path);
	}

	@Override protected String i_getName(String path)
	{
		// remove trailing slashes
		while (path.charAt(path.length()-1)=='/') path=path.substring(0,path.length()-1);
		
		int lastSlashIndex = path.lastIndexOf('/');
		return path.substring(lastSlashIndex+1);
	}

	// TODO: handle the ".." dir
	@Override protected String i_getCanonicalPath(String path)
	{
		return path;
	}

	@Override protected boolean i_exists(String path)
	{
		return false;
	}

	@Override protected boolean i_mkdir(String path)
	{
		return true;
	}

	@Override protected boolean i_mkdirs(String path)
	{
		return true;
	}
	
	@Override protected boolean i_chown(String path, UserPrincipal user, GroupPrincipal group)
	{
		return true;
	}

	@Override protected boolean i_mv(String src, String dest) { return true; }

	@Override protected boolean i_delete(String path)
	{
		return true;
	}
	
	@Override protected boolean i_delete(String[] paths)
	{
		return true;
	}

	@Override protected boolean i_canRead(String path)
	{
		return true;
	}

	@Override protected boolean i_canWrite(String path)
	{
		return true;
	}

	@Override protected ArrayList<String> i_readText(String path)
	{
		return null;
	}

	@Override protected String i_getAbsolutePath(String path)
	{
		return path;
	}

	@Override protected void i_setWritable(String path, boolean writable)
	{

	}

	@Override protected boolean i_writeText(String path, ArrayList<String> contents)
	{
		return true;
	}

	@Override protected boolean i_appendText(String path, ArrayList<String> contents)
	{
		return false;
	}

	@Override protected void i_createNewFile(String path)
	{

	}

	@Override protected void i_setReadable(String path, boolean readable)
	{

	}

	@Override protected boolean i_canExec(String path)
	{
		return true;
	}

	@Override protected Calendar i_getLastModified(String path)
	{
		return new GregorianCalendar();
	}
	
	@Override protected PosixFileAttributes i_getPosixAttributes(Path path)
	{
		return null;
	}
	
	@Override protected long i_getFileSizeInBytes(String path)
	{
		return 0;
	}

	@Override
	protected boolean i_chmod(String path, String mode)
	{
		return true;
	}

	@Override protected boolean i_ln(String dest, String src)
	{
		return true;
	}
}
