package gov.anl.gmca.io.sim.dev;

import gov.anl.gmca.hutch.DevPmacMotor;
import gov.anl.gmca.io.Epics;
import gov.anl.gmca.io.PVLookup.PV_AUTOFIND;
import gov.anl.gmca.syslog.Log;
import gov.anl.gmca.util.Util;

// this command is only run if complete is 0, which should mean the PVs aren't filled in
public class SimAutoFind implements Runnable
{
	@Override public void run()
	{
		Log.note("Running SimAutoFind...");
		Epics.putInteger		(PV_AUTOFIND.complete,			0);
		Epics.putIntegerArray	(PV_AUTOFIND.coarseContour, 	new int[]{0});
		Epics.putIntegerArray	(PV_AUTOFIND.loopZ, 			new int[]{0});
		Epics.putDouble			(PV_AUTOFIND.faceOnOmega, 		0);
		
		// First the script does auto-centering, then it takes four more images
		// to determine the contour.  It leaves omega at the face-on position.
		Util.sleep(3000);
		
		int[] coarseContour = new int[]{640,480,14,613,99,570,59,498,55,491,55,335,81,163,139,61,227,11,297,12,299,19,301,20,301,94,289,110,285,613,101};
		double faceOnOmega = DevPmacMotor.get("gonio_omega").getPosition();
		int[] loopZ = new int[]{640,480,262,262,236,236,180,180,140,140,108,108,94,94,82,82,90,90,90,90,108,108,120,120,132,132,156,156,184,184,20,227,46,445,6,323,36,331,64,355,80,387,48,439,58,455,2,469,26,407,60,439,76,467,2,449,4,461,46,295,18,323,68,289,98,277,24,283,110,347,14,471,0,472,162,295,16,421,16,361,28,407,46,455,60,391,38,417,128,353,162,309,68,295,12,333,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
		
		Epics.putIntegerArray	(PV_AUTOFIND.coarseContour, 	coarseContour	);
		Epics.putIntegerArray	(PV_AUTOFIND.loopZ, 			loopZ			);
		Epics.putDouble			(PV_AUTOFIND.faceOnOmega, 		faceOnOmega		);
		Epics.putInteger		(PV_AUTOFIND.complete, 			1				);
		Log.note("SimAutoFind complete.");
	}
}
