package gov.anl.gmca.io.sim.dev;

import gov.anl.gmca.util.Util;

import java.util.ArrayList;
import java.util.Random;

// chooch takes as input a .dat file written by BluIce
// chooch outputs an .efs file (numerical) and a .ps file (graphical)
//
public class SimDistl implements Runnable
{
	private ArrayList<String> stdOut, stdErr;
	String filename;
	Random rand = new Random();
	
	public SimDistl(String filename, ArrayList<String> stdOut, ArrayList<String> stdErr)
	{
		this.filename=filename;
		this.stdOut=stdOut;
		this.stdErr=stdErr;
	}
	
	@Override public void run()
	{
		stdOut.add("distl.signal_strength: characterization of candidate Bragg spots");
		
		Util.sleep(1000);
		int i = rand.nextInt(100);
		
		stdOut.add("                     File : "+filename);
		stdOut.add("               Spot Total :      "+i);
		stdOut.add("      In-Resolution Total :      "+i);
		stdOut.add("    Good Bragg Candidates :      "+i);
		stdOut.add("                Ice Rings :      0");
		stdOut.add("      Method 1 Resolution :  10.00");
		stdOut.add("      Method 2 Resolution : None");
		stdOut.add("        Maximum unit cell : None");
		stdOut.add(" %Saturation, Top 0 Peaks :   0.00");
		stdOut.add("In-Resolution Ovrld Spots :      0");
		stdOut.add("");
		stdOut.add("Bin population cutoff for method 2 resolution: 20%");
		stdOut.add("");
		stdOut.add("Number of focus spots on image #1 within the input resolution range: 0");
	}
}
