package gov.anl.gmca.io.sim.dev;

import gov.anl.gmca.gui.GUI;
import gov.anl.gmca.io.Resources;
import gov.anl.gmca.io.Web.WebConnection;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.ImageData;
import org.eclipse.swt.graphics.ImageLoader;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.InputStream;

public class SimImgSrv
{
	private static final String[][] headerMap =
	{
		{"pixelSize",          "0.073242"},
		{"detectorTypeC64",    "0"},
		{"wavelength",         "1.0332"},
		{"distance",           "250.002"},
		{"originX",      	   "150.293"},
		{"originY",      	   "149.414"},
		{"time",               "0.5"}
	};
	
	public WebConnection getWebResponse(String urlString)
	{
		// convert the image file to an input stream
		InputStream is = getImageStream("/data/diff_image.jpg");
		//WebConnection conn = new WebConnection();
		
		// add the MAR image headers to the response
		for (String[] headerField : headerMap)
		{
			//conn.headerMap.put(headerField[0], headerField[1]);
		}
		
		// return
		//return conn;
		return null;
	}

	private InputStream getImageStream(String diskFullPath)
	{
		// convert file to image
		ImageLoader loader = new ImageLoader();
		InputStream imgStream = Resources.get().getInputStream(diskFullPath);
		loader.load(imgStream);
		Image diskImg = new Image(GUI.getDisplay(), loader.data[0]);
		
		// apply image transformations
		Image procImg = new Image(GUI.getDisplay(), diskImg.getBounds().width, diskImg.getBounds().height);
		GC imgGC = new GC(procImg);
		int[] screenXY = {0,0};
		imgGC.drawImage(diskImg, (int)screenXY[0], (int)screenXY[1]);
		
		// convert image to input stream
		ByteArrayOutputStream os = new ByteArrayOutputStream();
		loader = new ImageLoader();
		loader.data = new ImageData[]{procImg.getImageData()};
		loader.save(os, SWT.IMAGE_PNG);
		InputStream ret = new ByteArrayInputStream(os.toByteArray());
		
		return ret;
	}
	
	private static SimImgSrv inst;
	public static SimImgSrv get() { if (null==inst) inst=new SimImgSrv(); return inst; }
}
