package gov.anl.gmca.log;

import gov.anl.gmca.gui.GUI;
import gov.anl.gmca.io.Epics;
import gov.anl.gmca.io.PVLookup.PVName;
import gov.anl.gmca.io.PVLookup.PV_MISC;
import gov.aps.jca.dbr.DBR;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;

public class WdgParameter {
	
	private Label parLabel;
	private Label parUnits;
	public Label parVal;
	public static boolean isUpdate = false;
	protected Epics.EpicsValueMonitor monitor = null;

	public void setValue(final String val) {
		GUI.asyncExec(new Runnable() {
			public void run() {
				if (val.length() == 0)
					return;
				double value = Math.round(Double.valueOf(val) * 1000.0) / 1000.0;
				parVal.setText(Double.toString(value));
			}
		});
	}

	public WdgParameter(Composite parent, int style, String label,
			PVName _pvName, String _units, int isData) {
		GridData gd;
		final PVName pvName;
		String units;
		if (isData == 0)
			// TODO: this is a temporary fix
			if (_pvName.equals(PV_MISC.apsCurrent.toString()))
				pvName = PV_MISC.apsCurrent;
			else
				pvName = _pvName;
		else {

			pvName = _pvName;
		}

		units = _units;
		parLabel = new Label(parent, SWT.NONE);
		parLabel.setText(label);
		parLabel.setBackground(parent.getBackground());
		gd = new GridData();
		parLabel.setLayoutData(gd);

		parVal = new Label(parent, SWT.NONE);
		parVal.setBackground(parent.getBackground());
		gd = new GridData();
		parVal.setLayoutData(gd);

		parUnits = new Label(parent, SWT.NONE);
		parUnits.setBackground(parent.getBackground());
		parUnits.setText(units);
		gd = new GridData();
		parUnits.setLayoutData(gd);
		
		monitor = new Epics.EpicsValueMonitor() {
			@Override
			public void valueChanged(String pv, DBR value) {
				final String _pvName = pv;
				final DBR _value = value;
				
				if(!isUpdate)
					return;
				
				if (_pvName.equals(pvName.toString())) {
					
					GUI.asyncExec(new Runnable() {
						public void run() {
							double val = Math.round(Epics.dbrToDouble(_value) * 1000.0) / 1000.0;
							parVal.setText(Double.toString(val));
						}
					});
				}

			}
		};

		Epics.addMonitor(pvName, monitor);
	}
}
