package gov.anl.gmca.raster.cam;

import gov.anl.gmca.raster.ModelRasterCell;
import gov.anl.gmca.raster.ModelRasterGrid;
import gov.anl.gmca.raster.ModelRasterState;
import org.eclipse.swt.graphics.Rectangle;

import java.awt.*;

public class DrawViewImages
{
	private ModelRasterVideo model;
	public DrawViewImages(ModelRasterVideo model)
	{
		this.model = model;
	}
	
	public void drawImageViewCell(Graphics2D gr)
	{
		ModelRasterGrid grid = ModelRasterState.get().getCurrentRunModel().grid();
		int selectedCellIndex = model.vcViewImages.getSelectedCellIndex();
		if (selectedCellIndex >= 0)
		{
			ModelRasterCell cell = grid.getCellCopy(selectedCellIndex);
			highlightCell(cell,model,gr);
		}
	}
	
	public static void highlightCell(ModelRasterCell cell, ModelRasterVideo model, Graphics2D g2)
	{
		g2.setColor(Color.white);
		g2.setBackground(Color.white);
		
		// default cell bounds include top and left borders
		// here we remove them to highlight only the center of each cell and
		// leave a border
		Rectangle cellBounds = model.getCellScreenBounds(cell);
		if (null==cellBounds) return;
		cellBounds.x++;
		cellBounds.y++;
		cellBounds.width--;
		cellBounds.height--;

    	g2.setPaint(new Color(1,1,1,200f/255f));
		g2.fillRect(cellBounds.x,cellBounds.y,cellBounds.width,cellBounds.height);
	}
}
