/*
 * Raster takes images at evenly spaced positions in a grid, which can be constrained
 * by a user-defined polygon.  The raster interface uses the same "run" list that the
 * collect tab uses, except runs are only performed one at a time.  Columns can be sent
 * all at once to FPE, allowing for shutterless operation.
 * 
 * This base raster package contains the command classes to run raster operations.
 * CmdRaster is the base class for the other three raster commands, and CmdRasterAuto
 * uses CmdRasterDiff directly.
 * 
 * ModelRasterRunList contains ModelRasterRun objects, which in turn contain ModelRasterGrid
 * objects which contain ModelRasterCells.  ModelRasterSiteList and ModelRasterHits are
 * independent objects that contain sites and hits across all runs.
 * 
 * The subpackage calc generates lists of cells to collect, similar to the run calculator
 * in the collect package.  The cam and ui packages contain the raster tab interface.
 * And the util package contains miscellaneous functions that don't fit well into the other
 * packages.
 */

package gov.anl.gmca.raster;
