package gov.anl.gmca.raster.sonicc;

import gov.anl.gmca.gui.Main;
import gov.anl.gmca.io.Epics;
import gov.anl.gmca.io.Epics.EpicsValueMonitor;
import gov.anl.gmca.io.PVLookup.PV_SONICC;
import gov.aps.jca.dbr.DBR;

public class DevSONICC
{
    public static void init()
    {
        Epics.addMonitor(PV_SONICC.serverCMD, new EpicsValueMonitor() {
            @Override public void valueChanged(String pvName, DBR value) {
                handleServerResponse(Epics.dbrToString(value));
            }
        });
    }

    public static double getAngle_rad() {
        if (Main.SONICC_TEST_MODE) return Math.toRadians(3.42);
        return Math.toRadians(Epics.getDouble(PV_SONICC.axes_rotation));
    }

    // responses can be:
    private static void handleServerResponse(String response)
    {

    }

    public static void start()
    {

    }

    public static void abort()
    {

    }
}
