package gov.anl.gmca.raster.sonicc;

import gov.anl.gmca.io.Epics;
import gov.anl.gmca.raster.calc.RasterGeometry;
import gov.anl.gmca.util.PerfTimer;
import gov.anl.gmca.util.Point2D;
import gov.anl.gmca.util.SwingUtil;

import java.awt.*;
import java.awt.image.BufferedImage;

public class SONICCTest {
    @org.junit.Test
    public void testSONICC() {

        Epics.connect();

        // load sonicc img
        SONICCImage img = new SONICCImage("A");
        img.loadFromDisk();

        /*int origW = img.originalImg.getWidth(), origH = img.originalImg.getHeight();
        BufferedImage tgtImg = new BufferedImage(486, 486, img.originalImg.getType());
        Graphics2D g2 = tgtImg.createGraphics();
        g2.setRenderingHint(RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_BICUBIC);
        g2.scale(.5,.5);
        g2.rotate(Math.toRadians(3.0), origW/2, origH/2);
        g2.drawImage(img.originalImg, null, -13, -13);
        g2.dispose();
        SwingUtil.showImage(tgtImg, true);*/

        // apply transforms
        double angle_degr = 3.0;
        Point hr_size = new Point(640, 480);
        //Point2D hr_umPerPx = new Point2D(0.75, 0.748); // zoom=6
        Point2D hr_umPerPx = new Point2D(3.5, 3.5);
        Point2D sonicc_umPerPx = new Point2D(2.5, 2.73);
        Point2D hr_center = new Point2D(299.0, 277.0);
        boolean cropToRectangle = true;
        boolean cameraTransform = true;

        PerfTimer timer1 = new PerfTimer("transform: ");
        //img.transform(Math.toRadians(angle_degr), hr_size, hr_umPerPx, sonicc_umPerPx, hr_center, cropToRectangle, cameraTransform);
        img.transform(null, cropToRectangle, cameraTransform);
        timer1.printElapsedMs();

        // composite with HR image
        PerfTimer timer2 = new PerfTimer("apply: ");
        BufferedImage compositeImg = SONICCImage.applyToHRImg(img.transformedImg, img.hrTopLeft);
        timer2.printElapsedMs();

        // show the final image
        SwingUtil.showImage(compositeImg, true);
    }
}
