/* JBLUICE-100
 * Monitoring cryo-stream temperature or cold flow rate in Bluice. 
 * Pop-up a message if the temp is greater than 115K or when flow rate stays at 0.0
 */
package gov.anl.gmca.sample;

import gov.anl.gmca.io.Epics;
import gov.anl.gmca.io.PVLookup.PV_MISC;
import gov.aps.jca.dbr.DBR;

public class DevCryoJetMonitor {
	
	private double flow = 0.0;
	private double temp = 100.0;
	
	private static DevCryoJetMonitor devCryoJetMonitor = new DevCryoJetMonitor();;
	
	public DevCryoJetMonitor(){
		devCryoJetMonitor = this;
		initMonitor();
	}
	public static DevCryoJetMonitor getInstance() {
		return devCryoJetMonitor;
	}
	public double getCryoJetFlow () {
		return flow;
	}
	public double getCryoJetTemp () {
		return temp;
	}
	private void initMonitor() {
		Epics.addMonitor(PV_MISC.cryojetFlowInner, new Epics.EpicsValueMonitor() {

			@Override
			public void valueChanged(String pvName, DBR value) {
				final DBR _value = value;
				flow = Epics.dbrToDouble(_value);;
			}
		});
		Epics.addMonitor(PV_MISC.cryojetTempReadback, new Epics.EpicsValueMonitor() {

			@Override
			public void valueChanged(String pvName, DBR value) {
				final DBR _value = value;
				temp = Epics.dbrToDouble(_value);
				
			}
		});
	}
}
