/**
 * @author spothineni
 * 
 * This class handles the PV callbacks for multiple images per orientation
 */

package gov.anl.gmca.screening;

import gov.anl.gmca.io.Epics;
import gov.anl.gmca.io.PVLookup.PV_SCR;
import gov.aps.jca.dbr.DBR;

public class DevScreeningTasks {
	protected boolean connected = false;
	protected Epics.EpicsValueMonitor dbUpdatedMonitor;

	public static DevScreeningTasks get() {
		return inst;
	}

	protected static DevScreeningTasks inst = null;

	public DevScreeningTasks() {
		inst = this;
	}

	public void verifyConnected() {
		if (connected)
			return;

		Epics.addMonitor(PV_SCR.diffimages0, new Epics.EpicsValueMonitor() {
			@Override
			public void valueChanged(String pvName, DBR value) {
				int isR = Epics.dbrToInt(value);
				ModelScreeningTasks.DIFFIMAGES0 = isR;
				ModelScreeningTasks.get().ll.notifyListeners();
			}
		});
		Epics.addMonitor(PV_SCR.diffimages45, new Epics.EpicsValueMonitor() {
			@Override
			public void valueChanged(String pvName, DBR value) {
				int isR = Epics.dbrToInt(value);
				ModelScreeningTasks.DIFFIMAGES45 = isR;

				ModelScreeningTasks.get().ll.notifyListeners();
			}
		});
		Epics.addMonitor(PV_SCR.diffimages90, new Epics.EpicsValueMonitor() {
			@Override
			public void valueChanged(String pvName, DBR value) {
				int isR = Epics.dbrToInt(value);
				ModelScreeningTasks.DIFFIMAGES90 = isR;

				ModelScreeningTasks.get().ll.notifyListeners();
			}
		});

		connected = true;
	}

	public static void setDiffImages(int num, int imgs) {
		if (num == 0)
			Epics.putInteger(PV_SCR.diffimages0, imgs);
		if (num == 1)
			Epics.putInteger(PV_SCR.diffimages45, imgs);
		if (num == 2)
			Epics.putInteger(PV_SCR.diffimages90, imgs);
	}
}
