/**
 * WebIce model of SIL like a POJO
 */

package gov.anl.gmca.screening;

import java.util.ArrayList;

public class ModelRowData {
	static public String[] ColumnNames = { 
			"Select", "Port", "CrystalID",
			"Directory", "Comment", "Set",
			"Resolution", "Score", "Protein", "Images",
			"IceRings", "UnitCell", "Mosaicity", "Rmsd", "BravaisLattice",
			"Metal", "Spacegroup", "ModelPath","SequencePath" };

	static public int[] columnWidths = { 
			70, 50, 90, 
			90, 200,100, 100, 80, 100, 280, 
			100, 250, 80, 80, 80, 
			80, 100, 200, 200 };
	public Integer row = 0;
	public int selected = 0;
	public int order = 0;
	public int screened = 0;
	public Object col[] = new Object[ColumnNames.length];
	public ArrayList<String> prefixes = new ArrayList<String>();
	public String currentPrefix;
	public String selectedPrefix;
	
	public ModelRowData(int r) {
		row = r;
	}

	public ModelRowData(Integer r) {
		row = r;
	}

	public void setColumn(int c, Object s) {
		if (c < ColumnNames.length)
			col[c] = s;
	}

	static public int getColumnCount() {
		return ColumnNames.length;
	}

	static public String getColumnName(int c) {
		if (c < ColumnNames.length)
			return ColumnNames[c];

		return null;
	}
}
