/**
 * 
 * GUI for Robot Status
 */

package gov.anl.gmca.screening.ui;

import gov.anl.gmca.gui.GUI;
import gov.anl.gmca.io.Epics;
import gov.anl.gmca.io.PVLookup.PV_ROBOT;
import gov.anl.gmca.screening.ModelScreening;
import gov.anl.gmca.util.Util;
import gov.aps.jca.dbr.DBR;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;

public class WdgRobotStatus {

	Label robotStatusCurrent, robotStatusCurrent_1, robotStatusCurrent_2,
			wTime;
	Epics.EpicsValueMonitor monitor = null;
	private boolean cooldown_counter = false;
	private long cooldown_time = 0;
	public WdgRobotStatus(Composite parent, int style) {

		GridData gd = new GridData();
		gd.horizontalSpan = 3;
		gd.horizontalAlignment = SWT.FILL;
		gd.grabExcessHorizontalSpace = true;
		gd.verticalAlignment = GridData.FILL;
		wTime = new Label(parent, SWT.NONE);
		wTime.setText("warm-up in : ");
		wTime.setAlignment(SWT.CENTER);
		wTime.setBackground(GUI.BGCOLOR);
		wTime.setLayoutData(gd);

		Group statusGroup = new Group(parent, SWT.NONE);
		statusGroup.setBackground(GUI.BGCOLOR);
		GridLayout statusGrid = new GridLayout(2, false);
		gd = new GridData();

		gd.horizontalSpan = 3;
		gd.widthHint = 300;
		gd.heightHint = 130;
		gd.grabExcessHorizontalSpace = true;
		// gd.grabExcessVerticalSpace=true;
		gd.horizontalAlignment = GridData.FILL;
		statusGroup.setLayout(statusGrid);
		statusGroup.setLayoutData(gd);
		statusGroup.setText("Robot Status");

		String status = Epics.getString(PV_ROBOT.sta);
		String status1 = Epics.getString(PV_ROBOT.sta$1);
		String status2 = Epics.getString(PV_ROBOT.sta$2);

		if (!status.equals("") && status != null && status.length() > 9)
			status = status.substring(9);
		if (!status1.equals("") && status1 != null && status1.length() > 9)
			status1 = status1.substring(9);
		if (!status2.equals("") && status2 != null && status2.length() > 9)
			status2 = status2.substring(9);

		gd = new GridData();
		gd.widthHint = 60;
		gd.grabExcessHorizontalSpace = true;
		gd.grabExcessVerticalSpace = true;
		gd.horizontalAlignment = GridData.FILL;
		Label robotStatusCurrentLabel = new Label(statusGroup, SWT.NONE);
		robotStatusCurrentLabel.setBackground(GUI.BGCOLOR);
		robotStatusCurrentLabel.setFont(GUI.FONT_SCREENING_STATUS);
		robotStatusCurrentLabel.setText("Current : ");
		robotStatusCurrentLabel.setLayoutData(gd);

		gd = new GridData();
		gd.widthHint = 200;
		gd.grabExcessHorizontalSpace = true;
		gd.grabExcessVerticalSpace = true;
		gd.horizontalAlignment = GridData.FILL;
		robotStatusCurrent = new Label(statusGroup, SWT.NONE);
		robotStatusCurrent.setFont(GUI.FONT_10);
		String error = "";

		if (!status.equals("") || status != null)
			if (status.length() > 3)
				error = status.substring(0, 3);

		robotStatusCurrent.setText(status);
		
		if (error.equals("ERR")) {
			robotStatusCurrent.setForeground(new Color(GUI.getDisplay(), 255, 0, 0)); // red
		} else {
			robotStatusCurrent.setForeground(new Color(GUI.getDisplay(), 0, 255, 0)); //green
		}
		
		robotStatusCurrent.setLayoutData(gd);

		gd = new GridData();
		gd.widthHint = 60;
		gd.grabExcessHorizontalSpace = true;
		gd.grabExcessVerticalSpace = true;
		gd.horizontalAlignment = GridData.FILL;
		Label robotStatusCurrentLabel_1 = new Label(statusGroup, SWT.NONE);
		robotStatusCurrentLabel_1.setBackground(GUI.BGCOLOR);
		robotStatusCurrentLabel_1.setFont(GUI.FONT_SCREENING_STATUS);
		robotStatusCurrentLabel_1.setText("-1         : ");
		robotStatusCurrentLabel_1.setLayoutData(gd);

		gd = new GridData();
		gd.widthHint = 200;
		gd.grabExcessHorizontalSpace = true;
		gd.grabExcessVerticalSpace = true;
		gd.horizontalAlignment = GridData.FILL;
		robotStatusCurrent_1 = new Label(statusGroup, SWT.NONE);
		robotStatusCurrent_1.setBackground(GUI.BGCOLOR);

		if (!status.equals("") || status1 != null)
			if (status1.length() > 3)
				error = status1.substring(0, 3);

		if (error.equals("ERR")) {
			robotStatusCurrent_1.setForeground(new Color(GUI.getDisplay(), 255, 0, 0));
		} else {
			robotStatusCurrent_1.setForeground(new Color(GUI.getDisplay(), 0, 0, 0));
		} 
		robotStatusCurrent_1.setText(status1);
		robotStatusCurrent_1.setLayoutData(gd);

		gd = new GridData();
		gd.widthHint = 60;
		gd.grabExcessHorizontalSpace = true;
		gd.grabExcessVerticalSpace = true;
		gd.horizontalAlignment = GridData.FILL;
		Label robotStatusCurrentLabel_2 = new Label(statusGroup, SWT.NONE);
		robotStatusCurrentLabel_2.setBackground(GUI.BGCOLOR);
		robotStatusCurrentLabel_2.setSize(50, 20);
		robotStatusCurrentLabel_2.setFont(GUI.FONT_SCREENING_STATUS);
		robotStatusCurrentLabel_2.setText("-2         : ");
		robotStatusCurrentLabel_2.setLayoutData(gd);

		gd = new GridData();
		gd.widthHint = 200;
		gd.grabExcessHorizontalSpace = true;
		gd.grabExcessVerticalSpace = true;
		gd.horizontalAlignment = GridData.FILL;
		robotStatusCurrent_2 = new Label(statusGroup, SWT.NONE);
		robotStatusCurrent_2.setBackground(GUI.BGCOLOR);

		if (!status2.equals("") || status2 != null)
			if (status2.length() > 3)
				error = status2.substring(0, 3);

		if (error.equals("ERR")) {
			robotStatusCurrent_2.setForeground(new Color(GUI.getDisplay(), 255, 0, 0));
		} else
			robotStatusCurrent_2.setForeground(new Color(GUI.getDisplay(), 0,	0, 0));
		
		robotStatusCurrent_2.setText(status2);
		robotStatusCurrent_2.setLayoutData(gd);
		
		Epics.addMonitor(PV_ROBOT.sta, new Epics.EpicsValueMonitor() {

			@Override
			public void valueChanged(String pvName, DBR value) {
				final DBR _value = value;
				String status = Epics.dbrToString(_value);
				if (status.length() > 9)
					status = status.substring(9);
				else
					return;
				setStatus(robotStatusCurrent, status, true);
				
				/*"cool_down > 300s" cool_down counter
				 * parse the cool_down sec and warn the user if 
				 * it is taking more than 2 minutes
				 * */
				int lastSpace = status.lastIndexOf(" ");
				
				String secString = "1";
				if (lastSpace > 2) {
					secString = status.substring(lastSpace);
					secString = secString.replaceAll("[\\D]", "");
				}
				
				if(status.contains("cool_down")) {
					if(!cooldown_counter) {
						cooldown_time = System.currentTimeMillis();
					}
					if(cooldown_time != 0) {
						long current_time = System.currentTimeMillis();
						long elapse_time = current_time - cooldown_time;
						
						if((elapse_time/1000.0)  > 120) {
							cooldown_counter = false;
							cooldown_time = 0;

							String message = "Cool down still continuing after two minutes.\n"+
									"If it continues it may be that the liquid nitrozen levels in the dewar "
								   +"below the average limit. Please check the robot.";
							Util.asyncPopupError("Warning", message);
						}
					}
					cooldown_counter = true;
				} else {
						cooldown_counter = false;
						cooldown_time = 0;
				}
				/**** end of the cool_down counter check *****/		
			}
		});
		
		Epics.addMonitor(PV_ROBOT.sta$1, new Epics.EpicsValueMonitor() {

			@Override
			public void valueChanged(String pvName, DBR value) {
				final DBR _value = value;
				String status;
				status = Epics.dbrToString(_value);
				if (status.length() > 9)
					status = status.substring(9);
				else
					return;

				setStatus(robotStatusCurrent_1, status, false);
			}
		});
		
		Epics.addMonitor(PV_ROBOT.sta$2, new Epics.EpicsValueMonitor() {

			@Override
			public void valueChanged(String pvName, DBR value) {
				final DBR _value = value;
				String status;
				status = Epics.dbrToString(_value);
				if (status.length() > 9)
					status = status.substring(9);
				else
					return;

				setStatus(robotStatusCurrent_2, status, false);
			}
		});
		
		Epics.addMonitor(PV_ROBOT.w_tim, new Epics.EpicsValueMonitor() {

			@Override
			public void valueChanged(String pvName, DBR value) {
				
				final DBR _value = value;
				String time = Epics.dbrToString(_value);
				int time_int = Epics.dbrToInt(_value);
				GUI.asyncExec(new Runnable() {
					public void run() {
						if (time_int > 10000)
							wTime.setText("Gripper warm-up in : warm");
						else
							wTime.setText("Gripper warm-up in : " + time+ " s");	
					}
				});
			}
			
		});
	}
	private void setStatus(Label robotStatus, String status, boolean updateError) {
		
		final String error = status.length()>=3 ? status.substring(0,3) : "";
		final String statustemp = status;
		
		GUI.asyncExec(new Runnable() {
			public void run() {
				if (error.equals("ERR")) {
					robotStatus.setForeground(GUI.COLOR_RED);
					if (updateError) ModelScreening.robotError = statustemp;
				} else {
					if (robotStatus == robotStatusCurrent) {
						robotStatus.setForeground(GUI.COLOR_GREEN);
					} else {
						robotStatus.setForeground(GUI.COLOR_BLACK);
					}
				}
				
				robotStatus.setText(statustemp);
			}
		});
	}
}
