package gov.anl.gmca.server;

import gov.anl.gmca.common.client_server.RPC;

import java.util.HashMap;
import java.util.UUID;

public abstract class Worker implements Runnable
{
	protected Boolean parseOK = null;
	protected HashMap<String,String> params;
	protected RPC.RPCResult result = null;

	protected String id;
	protected String cmd;
	protected Thread thread;
	
	public Worker(String cmd)
	{
		this.cmd=cmd;
		this.id=UUID.randomUUID().toString();
		parseOK=true;
		result=RPC.RPCResult.NOT_STARTED;
		thread = new Thread(this);
		WorkerList.add(this);
	}
	
	public void start()
	{
		thread.start();
		result = RPC.RPCResult.RUNNING;
	}
	
	public String getID() { return id; }
	
	public String initialJSONResponse()
	{
		return id;
	}
	
	public String jsonStatus()
	{
		return "id="+id+" cmd="+cmd+" result="+result;
	}
}
