package gov.anl.gmca.server.workers;

import gov.anl.gmca.common.client_server.RPC.RPCResult;
import gov.anl.gmca.hutch.DevAutocenter;
import gov.anl.gmca.server.Worker;

public class AutoCenter extends Worker
{
    public static enum CENTER_MODE { LOOP, CRYSTAL }

    private CENTER_MODE mode;
    public AutoCenter(CENTER_MODE mode) { super("AutoCenter"); this.mode=mode; }

    @Override
    public void run()
    {
        switch (mode)
        {
        case CRYSTAL:
            DevAutocenter.get().syncExecCrystal();
            break;
        case LOOP:
            DevAutocenter.get().syncExecLoop();
            break;
        }
        result = RPCResult.OK;
    }

    @Override
    public String jsonStatus()
    {
        return "id="+id+" result="+result;
    }
}
