package gov.anl.gmca.server.workers;

import gov.anl.gmca.common.DevMove.MoveCmd;
import gov.anl.gmca.common.DevMove.MoveResult;
import gov.anl.gmca.common.DevMoveFloat;
import gov.anl.gmca.common.client_server.RPC.RPCResult;
import gov.anl.gmca.server.Worker;
import gov.anl.gmca.util.Util;

public class MotorMove extends Worker
{
	private String motor;
	private double dest;
	public double actpos;
	
	public MotorMove(String motor, double dest)
	{
		super("MotorMove");
		this.motor = motor;
		this.dest = dest;
	}
	
	@Override
	public void run()
	{
		DevMoveFloat dev = ((DevMoveFloat)DevMoveFloat.getDevice(motor));
		MoveCmd move = dev.startMove(dest);
		while (true)
		{
			actpos = dev.getPosition();
			
			if (dev.inLocalMove())
			{
				result = RPCResult.RUNNING;
			}
			else
			{
				MoveResult moveResult = move.getResult();
				switch (moveResult.type)
				{
				case NOT_STARTED:
					result = RPCResult.NOT_STARTED;
					break;
				case INVALID:
				case ABORTED:
				case ERROR:
					result = RPCResult.ERROR;
					return;
				case SUCCESS:
					result = RPCResult.OK;
					return;
					
				}
			}
			Util.sleep(100);
		}
	}
	
	@Override
	public String jsonStatus()
	{
		return "id="+id+" cmd="+cmd+" result="+result+" pos="+Util.printDouble(actpos, 1);
	}
}
