package gov.anl.gmca.spotfinder;

import gov.anl.gmca.collect.DevFPE;
import gov.anl.gmca.collect.DevFPE2;
import gov.anl.gmca.common.DBConfig;
import gov.anl.gmca.common.DevDataDir;
import gov.anl.gmca.common.Redis;
import gov.anl.gmca.gui.Main;
import gov.anl.gmca.gui.options.DevUserConfig;
import gov.anl.gmca.gui.state.SWServer;
import gov.anl.gmca.hutch.DevKeithleyAmp;
import gov.anl.gmca.io.Database;
import gov.anl.gmca.io.Epics;
import gov.anl.gmca.sample.DBBeamSize;
import gov.anl.gmca.sample.DevSlider;
import gov.anl.gmca.util.PerfTimer;
import gov.anl.gmca.util.Util;

import java.nio.FloatBuffer;
import java.util.ArrayList;
import java.util.List;

public class TestSF
{
    @org.junit.Test
    public void testSF()
    {
        Epics.connect();
        Database.init();
        new DBConfig();

        new DevUserConfig();
        DBBeamSize.init();
        DevSlider.init();
        new DevDataDir();
        new DevSFType(DevSFType.SFRunType.COLLECT);
        new DevSFType(DevSFType.SFRunType.RASTER);
        SpotFinderQueue.init();
        new DevFPE2();
        new DevKeithleyAmp();
        SWServer.get().init();
        Redis.reset(false);

        String fullDir = DevFPE.get().getImageViewerFile().directory;
        String filename = DevFPE.get().getImageViewerFile().filename;
        String rel_dir = DevDataDir.getRelative(fullDir);
        String prefix = filename.substring(0,filename.indexOf("_"));
        int runLabel = 1;
        String output = "dials:spots4a";
        String key = Redis.image_stats(rel_dir,prefix,runLabel,output);

        CmdSpotFinderRemote sfcmd = new CmdSpotFinderRemote(SFData.SFType.COLLECT, DevSFType.SFRunType.COLLECT, 0, 0, fullDir, new ArrayList<>(List.of(filename)), prefix, runLabel, 50, 1, 0, DevSFType.SPOTFINDER_TYPE.DIALS_SPOTFINDER, null, CmdSpotFinder.TIMEOUT_DEFAULT_MS);
        SpotFinderQueue.submitTask(sfcmd);

        while (true) {Util.sleep(1000);}

        /*FloatBuffer data = DBImageStats.load(key);
        for (int i=0;i<data.capacity();i++) {
            System.out.println(i+": "+data.get(i));
        }*/
    }
}
