/**
 * Strategy tab Help sub-tab GUI
 */

package gov.anl.gmca.strategy;

import gov.anl.gmca.gui.GUI;
import gov.anl.gmca.io.ExecTask;
import gov.anl.gmca.util.ListenerList;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.Bullet;
import org.eclipse.swt.custom.StyleRange;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.GlyphMetrics;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;

public class WdgStrategyHelp extends Composite implements
					ListenerList.Listener<ModelStrategyResultList>, PaintListener{
	protected Button helpButton, videoButton;
	public static String XDS_VERSION = "XDS";
	public static String CCP4_VERSION = "CCP4";
	public static String POINTLESS_VERSION = "POINTLESS";
	public static String AIMLESS_VERSION = "AIMLESS";
	
	public WdgStrategyHelp(Composite parent, int style) {
		super(parent, style);

		GridLayout gl = new GridLayout(1, false);
		gl.marginWidth = 0;
		gl.marginHeight = 0;
		gl.horizontalSpacing = 0;
		gl.verticalSpacing = 3;
		setLayout(gl);

		createHelp();
		updateTable();
	}

	protected void createHelp() {
		GridData gd = new GridData(SWT.FILL, SWT.FILL, true, true);
		gd.widthHint = 630;
		
		Composite helpGroup = new Composite(this, SWT.NONE);
		helpGroup.setBackground(GUI.BGCOLOR);
		
		GridLayout actionGrid = new GridLayout(4, false);
		helpGroup.setLayout(actionGrid);

		gd = new GridData(SWT.FILL, SWT.DEFAULT, true, false);
		gd.horizontalSpan = 4;

		helpGroup.setLayoutData(gd);
		helpGroup.setFont(GUI.FONT_COLLECT_GROUP);
		
		/*helpButton = new Button(helpGroup, SWT.PUSH);
		helpButton.setText("Help");
		helpButton.setBackground(GUI.COLOR_BLUE_BUTTON);
		gd = new GridData(SWT.CENTER, SWT.DEFAULT, true, false);
		gd.horizontalSpan = 2;
		gd.minimumWidth = 120;
		helpButton.setLayoutData(gd);
		
		helpButton.addSelectionListener(new SelectionListener() {

			@Override
			public void widgetDefaultSelected(SelectionEvent arg0) {}

			@Override
			public void widgetSelected(SelectionEvent arg0) {
				
				String filename = Main.getAppDir()+"/java/docs/autoprocessing.pdf";
				ExecTask.new_ExecTask("firefox " + filename + "", "firefox",
						false, false).start();
			}	
		});*/
		
		videoButton = new Button(helpGroup, SWT.PUSH);
		videoButton.setText("Video Tutorial");
		videoButton.setBackground(GUI.COLOR_BLUE_BUTTON);
		gd = new GridData(SWT.CENTER, SWT.DEFAULT, true, false);
		gd.horizontalSpan = 4;
		videoButton.setLayoutData(gd);
		
		videoButton.addSelectionListener(new SelectionListener() {

			@Override
			public void widgetDefaultSelected(SelectionEvent arg0) {}

			@Override
			public void widgetSelected(SelectionEvent arg0) {
				
				String filename = "http://www.gmca.aps.anl.gov/video/collect-general.html";
				ExecTask.new_ExecTask("firefox " + filename + "", "firefox",
						false, false).start();
			}
			
		});
		
		// create the styled text for processing help text
		gd = new GridData(SWT.FILL, SWT.FILL, true, true);
		gd.horizontalSpan = 4;
		StyledText helpWidget = new StyledText(helpGroup, SWT.BORDER | SWT.WRAP);
		helpWidget.setText("Strategy will use following software through WebIce scripts\n"
				+ "\n"
				+ "LABELIT\t(Autoindexing)\n"
				+ "MOSFLM\t(Integration & Strategy)\n"
				+ "BEST\t\t(Strategy)\n\n"
				+ "To switch between MOSFLM and BEST strategy select it from JBluIce top menu Tools -> Options -> Strategy Program.\n\n"
				+ "To run strategy for different space group select it from the Space group drop down. When strategy generated it "
				+ "automatically updates the corresponding row of Screening tab spreadsheet\n\n"
				+ "Double clicking on the row of All Results tab will load corresponding strategy results to Strategy tab");
		StyleRange style0 = new StyleRange();
		style0.metrics = new GlyphMetrics(0, 0, 40);
		Bullet bullet0 = new Bullet (style0);
		helpWidget.setLayoutData(gd);
		
		int tip1 = 6;
		helpWidget.setLineBullet(tip1, 1, bullet0);
		helpWidget.setLineJustify(tip1, 1, true);
		helpWidget.setLineBackground(tip1, 1, GUI.BGCOLOR);
		
		int tip2 = 8;
		helpWidget.setLineBullet(tip2, 1, bullet0);
		helpWidget.setLineJustify(tip2, 1, true);
		
		int tip3 = 10;
		helpWidget.setLineBullet(tip3, 1, bullet0);
		helpWidget.setLineJustify(tip3, 1, true);
		helpWidget.setLineBackground(tip3, 1, GUI.BGCOLOR);
		addPaintListener(this);
	}

	public void updateTable() {
		GUI.asyncExec(new Runnable() {
			public void run() {
				
				
			}
		});
	}

	public void connectListeners() {
		
	}

	@Override
	public void paintControl(PaintEvent e) {
		
	}

	@Override
	public void handleEvent(ModelStrategyResultList object, Object data) {
		// TODO Auto-generated method stub
		
	}
}
