package gov.anl.gmca.syslog;

import gov.anl.gmca.io.Resources;
import gov.anl.gmca.users.ModelUserTable.Client;
import org.apache.log4j.Level;
import org.apache.log4j.Logger;
import org.apache.log4j.PropertyConfigurator;
import org.apache.log4j.contrib.LoggingOutputStream;

import java.io.File;
import java.io.IOException;
import java.io.PrintStream;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Properties;

// Redirect stdout/stderr to log4j
public class TextLog
{
	protected static Logger logger = Logger.getRootLogger();
	protected static boolean logConnected = false;
	public static boolean isLogConnected() { return logConnected; }
	
	public static void init(boolean logToFile)
	{
		if (logToFile)
		{
			String logDirName = "/var/tmp/bluice-"+Client.getUser();
			File logDir = new File(logDirName);
			if (!logDir.exists())
			{
				logDir.mkdirs();
			}
			
    		String filenamePrefix = logDirName+"/"+Client.getUser()+"-";
    		DateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd-HH-mm-ss");
    	    Date dateNow = new Date();
    	    String filenameTimestamp = dateFormat.format(dateNow);
    	    String filenameSuffix = "-"+Client.getPid()+".log";
    		System.setProperty("log.filename", filenamePrefix+filenameTimestamp+filenameSuffix);
    		
    		try
    		{
        		Properties properties = new Properties();
				properties.load(Resources.get().getInputStream("data/log4j-file.properties"));
	    		PropertyConfigurator.configure(properties);
			}
    		catch (IOException e) { e.printStackTrace(); }
		}
		else
		{
    		try
    		{
        		Properties properties = new Properties();
    			properties.load(Resources.get().getInputStream("data/log4j-console.properties"));
        		PropertyConfigurator.configure(properties);
			}
    		catch (IOException e) { e.printStackTrace(); }
		}
		System.setOut(new PrintStream(new LoggingOutputStream(logger,Level.INFO),true));
		System.setErr(new PrintStream(new LoggingOutputStream(logger,Level.ERROR),true));
		logConnected = true;
	}
}
