package gov.anl.gmca.users;

import gov.anl.gmca.common.Redis;
import redis.clients.jedis.Jedis;

public class DevPyBluIceUsers
{
    // returns -1 if no active slot, -2 on error
    public static int activeSlot()
    {
        try (Jedis jedis = Redis.getPyBluIce()) {
            for (int client_i=0; client_i < 10; client_i++) {
                boolean active = jedis.hget("bluice:clients#" + client_i, "isActive").equals("1");
                if (active) return client_i;
            }
            return -1;
        } catch (Exception e) { e.printStackTrace(); return -2; }
    }

    public static boolean takeOver()
    {
        int active_slot = activeSlot();
        if (active_slot < 0) return false;
        try (Jedis jedis = Redis.getPyBluIce()) {
            System.out.println("Taking over active from PyBluIce client slot "+active_slot);
            jedis.hset("bluice:clients#"+active_slot, "isActive", "0");
            return true;
        } catch (Exception e) { e.printStackTrace(); return false; }
    }
}
