package gov.anl.gmca.util;

import org.eclipse.swt.graphics.Point;

public class Point2D
{
	public Point2D(Point2D p) { this.x=p.x; this.y=p.y; }
	public Point2D(double x, double y) { this.x=x; this.y=y; }
	public Point2D(double[] xy)
	{
		if (null==xy || xy.length != 2) throw new IllegalArgumentException();
		this.x=xy[0]; this.y=xy[1];
	}
	public double x,y;
	
	public Point round()
	{
		return new Point((int)Math.round(x),(int)Math.round(y));
	}
	
	public Point2D plus(Point2D rhs)
	{
		return new Point2D(x+rhs.x,y+rhs.y);
	}
	public Point2D minus(Point2D rhs)
	{
		return new Point2D(x-rhs.x,y-rhs.y);
	}
	public double dist(Point2D rhs) {
		Point2D dist = minus(rhs);
		return Math.sqrt(dist.x*dist.x+dist.y*dist.y);
	}
	public Point2D div(double divisor) { return new Point2D(x/divisor,y/divisor); }
	public Point2D rotate(double radians) {
		double _x = x*Math.cos(radians)-y*Math.sin(radians);
		double _y = x*Math.sin(radians)+y*Math.cos(radians);
		return new Point2D(_x,_y);
	}

	public String toString(int decimals) { return Util.sprintf("%."+decimals+"f,%."+decimals+"f", x, y); }
}
