package gov.anl.gmca.util;

import gov.anl.gmca.gui.Main;
import gov.anl.gmca.io.Disk;
import gov.anl.gmca.io.Epics;
import gov.anl.gmca.io.ExecTask;
import gov.anl.gmca.io.PVLookup.PVName;
import gov.anl.gmca.io.PVLookup.PV_RUN;
import gov.anl.gmca.io.PVLookup.PV_RUNS;

import java.util.ArrayList;
import java.util.StringTokenizer;

public class SaveState
{
	public static void save()
	{
		String output = "";
		
		for (PV_RUNS runsPV : PV_RUNS.values())
		{
			output += runsPV.toString()+"="+Epics.getString(runsPV)+"\n";
		}
		
		int runCount = Epics.getInteger(PV_RUNS.runCount);
		for (int runIndex=0; runIndex<=runCount; runIndex++)
		{
			for (PV_RUN runPV : PV_RUN.values())
			{
				output += runPV.run(runIndex).toString()+"="+Epics.getString(runPV.run(runIndex))+"\n";
			}
		}
		
		ArrayList<String> contents =  new ArrayList<String>();
		contents.add(output);
		Disk.writeText(System.getenv("HOME")+"/bluice_temp/pvSave.txt", contents);
	}
	
	static class SavedPV implements PVName
	{
		private String name;
		public SavedPV(String name) { this.name=name; }
		@Override public String toString() { return name; }
	}
	
	public static void load()
	{
		// reload SQL
		ExecTask sqlTask = ExecTask.new_ExecTask("mysql -u dhs -h bl3upper user_data", "mysql", false);
		sqlTask.inputFilename = Main.getAppDir()+"/data/SpotFinderResults.sql";
		sqlTask.start();
		sqlTask.waitFor();
		
		// reload PVs
		ArrayList<String> contents = Disk.readText(System.getenv("HOME")+"/bluice_temp/pvSave.txt");
		for (String line : contents)
		{
			StringTokenizer st = new StringTokenizer(line,"=");
			
			if (!st.hasMoreTokens()) continue;
			String pvNameString = st.nextToken();
			String pvValue = st.hasMoreTokens() ? st.nextToken() : "";
			
			Epics.put(new SavedPV(pvNameString), pvValue);
		}
		
		// trigger run reload
		Epics.putInteger(PV_RUNS.updated, 0);
		Epics.putInteger(PV_RUNS.updated, 1);
		
		int runCount = Epics.getInteger(PV_RUNS.runCount);
		for (int runIndex=0; runIndex<=runCount; runIndex++)
		{
			Epics.putInteger(PV_RUN.updated.run(runIndex), 0);
			Epics.putInteger(PV_RUN.updated.run(runIndex), 1);
			Epics.putInteger(PV_RUN.dbUpdated.run(runIndex), -1);
			Epics.putInteger(PV_RUN.dbUpdated.run(runIndex), -2);
		}
	}
}
