import gov.anl.gmca.common.*;
import gov.anl.gmca.io.*;
import gov.anl.gmca.raster.sonicc.*;
import gov.anl.gmca.sample.*;
import gov.anl.gmca.server.*;
import gov.anl.gmca.util.*;
import redis.clients.jedis.*;

import java.util.*;

import static gov.anl.gmca.server.DeviceInit.*;

public class TestFPE
{
    @org.junit.Test
    public void testFPE()
    {
        SimBeamline.start();
        Epics.connect();
        initMotors();
        initMotorAssemblies();
        new DevDataDir();

        for (int i=0;i<3;i++) {
            System.out.println("Waiting for devices to connect...");
            Util.sleep(1000);
        }
        System.out.println("Starting test");

        String[][] values = new String[][]{
            {"FPE:delta",".2"},
            {"FPE:energy","12"},
            {"FPE:exposureTime",".2"},
            {"FPE:startAngle","0.0"},
            {"FPE:nextAngle","0.2"},
            {"FPE:frameNumber","0"},
            {"FPE:runNumber","1"},
            {"FPE:filename","A2_1_00001.cbf"},
            {"FPE:directory256","/mnt/beegfs/mhilgart/23BM_2019_06_05_cbf/A1"},
            {"FPE:mode256","0 1 0 0 0 0 0 0 0 0 1"},
        };
        for (String[] pv : values) {
            ArrayList<String> cmd = new ArrayList<>();
            cmd.add("caput");
            if (pv[0].contains("256")) cmd.add("-S");
            cmd.add("23sim:"+pv[0]);
            cmd.add(pv[1]);
            String env = "EPICS_CA_ADDR_LIST=127.0.0.1:8002 "+System.getenv("EPICS_CA_ADDR_LIST");
            env += ";PYTHONUNBUFFERED=1";
            ExecTask2.execCmd(cmd,env,false,null,0,true);
        }
        Util.sleep(10000);
    }
}
