import gov.anl.gmca.collect.CmdCollectJet;
import gov.anl.gmca.common.DevDataDir;
import gov.anl.gmca.gui.Main;
import gov.anl.gmca.hutch.DevShutter;
import gov.anl.gmca.io.Epics;
import gov.anl.gmca.sample.DevSlider;
import gov.anl.gmca.spotfinder.DevSFType;
import gov.anl.gmca.spotfinder.DevSFType.SFRunType;
import gov.anl.gmca.spotfinder.SpotFinderQueue;
import gov.anl.gmca.util.Util;

public class TestJetCollect
{
    @org.junit.Test
    public void jetTest()
    {
        Epics.connect();
        DevShutter.init();
        DevSlider.init();
        new DevDataDir();
        new DevSFType(SFRunType.COLLECT);
        new DevSFType(SFRunType.RASTER);
        SpotFinderQueue.init();
        Main.FAKE_DATA=true;

        String dir = "A1";
        String subDir = "001";
        String prefix = "A1";
        double exp_sec = 0.01;
        int framesPerDir = 1000;

        CmdCollectJet cmd = new CmdCollectJet(dir, subDir, prefix, exp_sec, framesPerDir, 1, 3);
        cmd.start();

        // let it collect for 5 seconds
        //Util.sleep(5000);
        //cmd.pause();

        // wait for cmd to complete
        while (cmd.thread.isAlive()) {
            Util.sleep(10);
        }
        Util.sleep(5000);
    }
}
