import gov.anl.gmca.io.Database.*;
import gov.anl.gmca.util.*;

import java.sql.*;
import java.util.*;

public class TestSQL {
    @org.junit.Test
    public void testSQL() {
        Connection conn = null;
        try {
            String url = "jdbc:sqlite:/home/mhilgart/bluice/data/blc2004.sqlite";
            conn = DriverManager.getConnection(url);
            System.out.println("Connection to SQLite has been established.");

            Statement st = conn.createStatement();
            st.execute("select * from Config order by ID");

            ResultSet rs = st.getResultSet();
            if (null != rs) {
                // get column names
                ResultSetMetaData rsmd = rs.getMetaData();
                int columnCount = rsmd.getColumnCount();
                String[] colNames = new String[columnCount];
                for (int i = 0; i < columnCount; i++) {
                    // getColumnName uses 1-based indices!
                    colNames[i] = rsmd.getColumnName(i + 1);
                }

                // process rows
                ArrayList<HashMap<String, String>> ret = new ArrayList<HashMap<String, String>>();
                while (rs.next()) {
                    HashMap<String, String> hm = new LinkedHashMap<String, String>();
                    for (int i = 0; i < colNames.length; i++) {
                        // ResultSet.getString also uses 1-based indices
                        hm.put(colNames[i], rs.getString(i + 1));
                    }
                    ret.add(hm);
                }

                // print output
                for (HashMap<String,String> row : ret) {
                    Util.printf("%s = %s", row.get("ID"), row.get("Value"));
                }
            }
        } catch (SQLException e) {
            System.out.println(e.getMessage());
        } finally {
            try {
                if (conn != null) conn.close();
            } catch (SQLException ex) {
                System.out.println(ex.getMessage());
            }
        }
    }
}