package gov.anl.aps.gmca;

import javax.swing.*;    
import javax.swing.event.*;    
import java.awt.*;
import java.awt.event.*;

public class GUI
{
	public static final Color bgColor = new Color(235,235,235);
	public static final Color btnColor = new Color(235,235,235);
	
	public GUI()
	{
		JFrame frame = new JFrame("BluIce DB config: Beamline "+Main.getBeamlineName());
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.setBackground(bgColor);

		JPanel jplMain = new JPanel(new GridBagLayout());
		jplMain.setBackground(bgColor);
		frame.getContentPane().add(jplMain);
		
		GridBagConstraints gbc = new GridBagConstraints();
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(10,5,5,5);
		
		JLabel lblDbp = new JLabel("Enter Hutch detector position");
		gbc.gridx = 0;
		gbc.gridy = 0;
		gbc.gridwidth = 1;
		jplMain.add(lblDbp, gbc);

		double valDbp = DB.getDouble("detector_back_pos");
		SpinnerModel sm = new SpinnerNumberModel(valDbp, 0.0, 3000.0, 5.0);
		
		final JSpinner spnDbp = new JSpinner(sm);
		gbc.gridx = 1;
		gbc.gridy = 0;
		gbc.gridwidth = 1;
		jplMain.add(spnDbp, gbc);
		
		spnDbp.addChangeListener(new javax.swing.event.ChangeListener() {
			public void stateChanged(javax.swing.event.ChangeEvent e) {
				DB.setDouble("detector_back_pos",((Double)spnDbp.getValue()).doubleValue());
			}
		});

		JLabel lblCe = new JLabel("Collimator enable");
		gbc.gridx = 0;
		gbc.gridy = 1;
		gbc.gridwidth = 1;
		gbc.insets = new Insets(5,5,10,5);
		jplMain.add(lblCe, gbc);

		final JRadioButton tBtnCe = new JRadioButton("Enable");
		tBtnCe.setActionCommand("Enable");
		tBtnCe.setBackground(bgColor);
		gbc.gridx = 1;
		gbc.gridy = 1;
		gbc.gridwidth = 1;
		jplMain.add(tBtnCe, gbc);
		
		final JRadioButton fBtnCe = new JRadioButton("Disable");
		fBtnCe.setActionCommand("Disable");
		fBtnCe.setBackground(bgColor);
		gbc.gridx = 2;
		gbc.gridy = 1;
		gbc.gridwidth = 1;
		jplMain.add(fBtnCe, gbc);

		tBtnCe.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				boolean isSelected = (tBtnCe.getSelectedObjects() != null);
				DB.setBoolean("collimator_enable", isSelected);
			}
		});
		

		ButtonGroup group = new ButtonGroup();
		group.add(tBtnCe);
		group.add(fBtnCe);

		if (DB.getBoolean("collimator_enable"))
		{
			tBtnCe.setSelected(true);
		}
		else
		{
			fBtnCe.setSelected(true);
		}
		
		frame.pack();
		frame.setVisible(true);
	}
}
