package gov.anl.aps.gmca;

public class Main
{
	public static String beamline = null;
	
	protected static String[][] config =
	{
			{"23i","ID-D", "bl1upper"},
			{"23o","ID-B", "bl2upper"},
			{"23b","BM",   "bl3upper"}
	};
	
	public static String getBeamlineName()
	{
		for (int i=0;i<config.length;i++)
		{
			if (config[i][0].equals(beamline)) return config[i][1];
		}
		return "";
	}
	
	public static String getHostname()
	{
		for (int i=0;i<config.length;i++)
		{
			if (config[i][0].equals(beamline)) return config[i][2];
		}
		return "";
	}
	
	public static void setBeamline(String bl)
	{
		for (int i=0;i<config.length;i++)
		{
			if (config[i][0].equals(bl))
			{
				beamline = bl;
				return;
			}
		}
		System.out.println("Invalid beamline: "+bl);
		System.exit(-1);
	}
	
	public static void main(String[] args)
	{
		if (args.length != 1)
		{
			System.out.println("Usage: java Main [23i|23o|23b]");
			return;
		}
		setBeamline(args[0]);
		
		GUI gui = new GUI();
	}
}
