#!/bin/bash

######################################################################

function isAlive()
{
    return `ps -p $1 --no-headers|wc -l`
}

######################################################################

#echo "BI PID:  $BluIcePID"
#echo "Command: $ExecCommand"

# Remove JBluIce-specific GTK options
unset GTK_THEME
unset XDG_CONFIG_HOME

# make sure BluIce is alive before running the command
isAlive $BluIcePID
if [ $? = 0 ]
then
    echo "BluIce pid $BluIcePID is not running, aborting command" >&2
    exit -1
fi

# run the command
$ExecCommand <&0 &
taskPid=$!

# monitor BluIce
while true
do
  # if the task ends, quit
  isAlive $taskPid
  if [ $? = 0 ]
  then
      wait $taskPid
      exitVal=$?
      #echo "Task finished, returning exit value $exitVal" >&2
      exit $exitVal
  fi

  # if BluIce dies, kill the command
  isAlive $BluIcePID
  if [ $? = 0 ]
  then
      echo "Sending SIGKILL to $taskPid" >&2
      kill -9 $taskPid
      exit -1
  fi

  sleep .001
done
