#!/bin/csh
#
# Running XDS for multiple lattice case, works only on 23ID beamlines @APS
#
# Usage : run_multiplelattice.csh <file_prefix>
#
# Ver 1 : Sudhir Babu Pothineni, 
# GM/CA CAT, APS, Argonne National Laboratory
# Ver 2 : runs fast_dp 05/15/2013
#
# Reference : http://strucbio.biologie.uni-konstanz.de/xdswiki/index.php/Indexing
cd $1
#generate_XDS.INP "../$2"
echo "checking error INSUFFICIENT PERCENTAGE $1"
if( -e XDS.LOG) then
	# check if XDS has error about insufficient percentage of spots
	set xds_error=(`cat XDS.LOG | awk '/INSUFFICIENT PERCENTAGE/{ print $0; }'`)

	if ( "$xds_error" != "") then 
	
		grep -v " 0 0 0" SPOT.XDS > SPOT.XDS_good
		mv SPOT.XDS SPOT.XDS_orig
		cp -p SPOT.XDS_good SPOT.XDS
		egrep -v "JOB=" XDS.INP > XDS.INP_new
		mv XDS.INP_new XDS.INP
		echo "JOB= IDXREF" >> XDS.INP
		/mnt/software/px/XDS/xds_par >& XDS.LOG
		sed "s/JOB\= IDXREF/\!JOB=  IDXREF/g" XDS.INP > XDS1.INP
		#sed "s/\!JOB\= DEFPIX/JOB= DEFPIX/g" XDS1.INP > XDS.INP
		echo "JOB= DEFPIX" >> XDS1.INP
		mv XDS1.INP XDS.INP
		echo "Rerunning XDS with only JOB= DEFPIX"
		/mnt/software/px/XDS/xds_par >& XDS.LOG
		
		sed "s/JOB\= DEFPIX/\!JOB= DEFPIX/g" XDS.INP > XDS1.INP
		#sed "s/\!JOB\= XPLAN/JOB= XPLAN/g" XDS1.INP > XDS.INP
		echo "JOB= XPLAN" >> XDS1.INP
		mv XDS1.INP XDS.INP
		/mnt/software/px/XDS/xds_par >& XDS.LOG
		
		rm -rf XDS1.INP
	endif
endif
