from pathlib import Path
from html import escape


class Htmlstr(str):
    '''turn a string into a html form'''

    def __new__(cls, value, to_html=False):
        # explicitly only pass value to the str constructor
        return super(Htmlstr, cls).__new__(cls, value)
        self.html = to_html

    def __init__(self, value, to_html=False):
        # ... and don't even call the str initializer
        self.html = to_html

    # if html flag is false, do nothing, else do html thing
    def convert(func):
        def inner(self, *args, **kwargs):
            if not self.html:
                return self
            else:
                # self = escape(self)
                self = self.replace("<", "&lt;").replace(">", "&gt;")
                return func(self, *args, **kwargs)

        return inner

    @convert
    def xplan_to_select(self):

        sb = ["<select name='form' onchange='location = this.value;'>",
              "<option selected disabled>Choose a multi-crystal strategy...</option>"]
        for opt in self.split("\n"):
            fields = opt.split("\\s+")
            if not opt.contains("start_angle") and len(fields) == 9:
                startOsc = fields[1]
                totalOsc = fields[2]
                endOsc = float(startOsc) + float(totalOsc)
                startCmpl = fields[5]
                endCmpl = fields[8]
                value = "export:%s:%s:%.1f".format(id, startOsc, endOsc)
                textOpt = "rot: %sdeg., start angle=%s, compl=%s%% => end cmpl=%s".format(totalOsc, startOsc, startCmpl,
                                                                                          endCmpl)
                sb.append("<option value='%s'>%s</option>".format(value, textOpt))
        sb.append("</select>")
        return "".join(sb)

    @convert
    def htmlSelectPointGroupChoices(self):
        sb = ["<select name='form' onchange='location = this.value;'>",
              "<option selected disabled>Choose an alternative space group...</option>"]
        for opt in self.split(";"):
            spg = opt[:opt.index(" ")]
            # value = "strategy2:%s:%s:%s:%s:%s:%s:%s:%s", id, prefix, pipeline, imgdir, workdir, anomalous, spg, defaultSpg)
            value = spg
            sb.append("<option value='%s'>%s</option>".format(value, opt))

        sb.append("</select>")
        return "".join(sb)

    @convert
    def wrap(self, tag):
        return "<{}>{}</{}>".format(tag, self, tag)

    @convert
    def uri(self):
        return Path(self).as_uri()




    @convert
    def toLinkOfHtmlButton(self, toUri=False, btnTitle="buttonTitle", btnText="linkText", linkTitle="linkTitle", target="_blank"):
        # create a link (directory or file)  of a button
        btn = "<button class='dt-button tooltip', title='{}'>{}</button>".format(btnTitle, btnText)
        btn = "{}".format(btnText)
        if toUri:
            link = "file:///{}".format(self)
        else:
            link = self

        link = "<a href='{}' title='{}' target='{}'>{}</a>".format(link, linkTitle, target, btn)
        return link

    @convert
    def htmlButton(self):
        return "<button class='dt-button tooltip'>{}</button>".format(self)


if __name__ == '__main__':
    a = Htmlstr("A", to_html=False)
    print(a.lower())
    print(a.wrap("a"))
    b = Htmlstr("/mnt/software", to_html=True)
    print(b.uri())

    c = Htmlstr("/mnt/software", to_html=True).toLinkOfHtmlButton()
    print(c)
    print(Htmlstr("Start", True).htmlButton())
