from __future__ import absolute_import
import os

# DB set up
MYSQLDB = {'dbname': 'user_data',
           'host': 'bl3upper',
           'user': 'dhs',
           'password': ''}

# doc says the following should also work, but not for me for some reason
# MYSQLDB = "mysql://qxu:password@127.0.0.1:3306/user_data"

PX = '/mnt/software/px'

# full paths for individual programs/plugins
XDS_HDF5_PLUGIN = "{PX}/dectris-neggia.so".format(PX=PX)
PROGRAM_FAST_DP = '{PX}/fast_dp/bin/fast_dp'.format(PX=PX)
PROGRAM_IPMOSFLM = '{PX}/CCP4/ccp4/bin/ipmosflm'.format(PX=PX)

# program to dump image header
IMG_HEADER_DUMPER = os.path.join(os.path.dirname(os.path.abspath(__file__)), 'imgheader')


XSCALE_MAXCC12 = "{PX}/XDS/xscale_maxcc12".format(PX=PX)
XDSCC12 = "{PX}/XDS/xdscc12".format(PX=PX)
XDSSTAT = "{PX}/XDS/xdsstat".format(PX=PX)


# DIALS & KAMO setup, (KAMO is installed as a module in DIALS)
DIALS_SETUP = "source {PX}/dials/dials_env.sh".format(PX=PX)
KAMO_SETUP = DIALS_SETUP

# set up environment for packages
PHENIX_SETUP = 'source {PX}/phenix/phenix_env.sh'.format(PX=PX)
CCP4_SETUP = 'source {PX}/CCP4/ccp4/bin/ccp4.setup-sh'.format(PX=PX)

# variable used to fool indexing program to recognize still images
# Minimum osc range allowed, if osc is less than this value, set it as the value
# XDS OSC must be multiple of 0.0001
MIN_OSC_VALUE = 0.0001

# MORDA molecular replacement
MORDA_SETUP_SH = """
MRD_DB={PX}/MoRDa_DB
case $(uname -s)_$(uname -m) in
    (Darwin_x86_64) MRD_PROG=$MRD_DB/bin_mac;;
    (Darwin_i?86) MRD_PROG=$MRD_DB/bin_mac;;
    (Linux_x86_64) MRD_PROG=$MRD_DB/bin_linux;;
    (Linux_i?86) MRD_PROG=$MRD_DB/bin_lin32;;
    (*) Error: cannot recognise platform, exiting.; exit;;
esac
export MRD_DB MRD_PROG
PATH=${{PATH}}:$MRD_PROG
""".format(PX=PX)