#! /bin/awk -f

# convert XDS "XPARM.XDS" file into XDS.INP-style inputs
#								-James Holton 
#
BEGIN{version="old"}

/VERSION/{version=$NF;next}

{++n;}

n==1{
    firstnum=$1;
    phi0 = $2;
    osc = $3;
    spindle_x=$4;spindle_y=$5;spindle_z=$6;
    print "STARTING_FRAME=",firstnum;
    print "STARTING_ANGLE=",phi0;
    print "OSCILLATION_RANGE=",osc;
    print "ROTATION_AXIS=",spindle_x,spindle_y,spindle_z;
}
n==2{
    wave=$1;
    print "X-RAY_WAVELENGTH=",wave;
    beam_x=$2;beam_y=$3;beam_z=$4;
    print "INCIDENT_BEAM_DIRECTION=",beam_x,beam_y,beam_z;
}
n==3 && version!="old" || n==8 && version=="old"{
    SGnum=$1;a=$2;b=$3;c=$4;alpha=$5;beta=$6;gamma=$7;
    print "SPACE_GROUP_NUMBER=",SGnum;
    print "UNIT_CELL_CONSTANTS=",a,b,c,alpha,beta,gamma;
}
n==4 && version!="old" || n==9 && version=="old"{
    a_x=$1;a_y=$2;a_z=$3;
    print "UNIT_CELL_A-AXIS=",a_x,a_y,a_z;
}
n==5 && version!="old" || n==10 && version=="old"{
    b_x=$1;b_y=$2;b_z=$3;
    print "UNIT_CELL_B-AXIS=",b_x,b_y,b_z;
}
n==6 && version!="old" || n==11 && version=="old"{
    c_x=$1;c_y=$2;c_z=$3;
    print "UNIT_CELL_C-AXIS=",c_x,c_y,c_z;
}
n==7 && version!="old"{
    nseg=$1;
    fpixels=$2;spixels=$3;fpix=$4;spix=$5;
    print "NX=",fpixels,"NY=",spixels,"QX=",fpix,"QY=",spix;
}
n==3 && version=="old"{
    fpixels=$1;spixels=$2;fpix=$3;spix=$4;
    print "NX=",fpixels,"NY=",spixels,"QX=",fpix,"QY=",spix;
}
n==8 && version!="old"{
    orgx=$1;orgy=$2;dist=$3;
    print "DETECTOR_DISTANCE=",dist;
    print "ORGX=",orgx,"ORGY=",orgy;
}
n==4 && version=="old"{
    dist=$1;orgx=$2;orgy=$3;
    print "DETECTOR_DISTANCE=",dist;
    print "ORGX=",orgx,"ORGY=",orgy;
}
n==9 && version!="old" || n==5 && version=="old"{
    detX_x=$1;detX_y=$2;detX_z=$3;
    print "DIRECTION_OF_DETECTOR_X-AXIS=",detX_x,detX_y,detX_z;
}
n==10 && version!="old" || n==6 && version=="old"{
    detY_x=$1;detY_y=$2;detY_z=$3;
    print "DIRECTION_OF_DETECTOR_Y-AXIS=",detY_x,detY_y,detY_z;
}
n==11 && version!="old" || n==7 && version=="old"{
    detZ_x=$1;detZ_y=$2;detZ_z=$3;
    print "! DIRECTION_OF_DETECTOR_Z-AXIS=",detZ_x,detZ_y,detZ_z;
}
