'''
Here is a list of all the possible crystallographic point groups, written as they will be accepted by CrystFEL.
Refer to this list if you experience difficulty with "-y" at any time.

Triclinic
    1, -1
Monoclinic
    2/m, 2, m
Orthorhombic
    mmm, 222, mm2
Tetragonal
    4/m, 4, -4, 4/mmm, 422, -42m, -4m2, 4mm
Trigonal (rhombohedral axes)
    3_R, -3_R, 32_R, 3m_R, -3m_R
Trigonal (hexagonal axes)
    3_H, -3_H, 321_H, 312_H, 3m1_H, 31m_H, -3m1_H, -31m_H
Hexagonal
    6/m, 6, -6, 6/mmm, 622, -62m, -6m2, 6mm
Cubic
    23, m-3, 432, -43m, m-3m

'''

CRYST_SYMMETRY = [
    '1', '-1',
    '2', '2/m',
    '222', 'mmm',
    '4', '4/m',
    '422', '4/mmm',
    '3_R', '-3_R', '32_R', '-3m_R',
    '3_H', '-3_H', '321_H', '-3m1_H', '312_H', '-31m_H',
    '6', '6/m',
    '622', '6/mmm',
    '23', 'm-3', '432', 'm-3m']
