import threading
import time
import os


class StreamMerger:
    def __init__(self, mqueue, merged_streams_file):
        self.queue = mqueue
        self.fh = open(merged_streams_file, "a")
        self.process = threading.Thread(target=self.merge)
        self.process.daemon = True
        self.process.start()

    def merge(self):
        while True:
            while not self.queue.empty():
                text_block = self.queue.get()
                self.fh.write(text_block)
            self.fh.flush()
            os.fsync(self.fh)
            time.sleep(10)

    def stop(self):
        self.fh.close()

    def is_alive(self):
        return self.process.is_alive()
