from sortedcollections import SortedDict
import random
import time, sys, os, logging
from multiprocessing import Process, Queue

from pyqtgraph.Qt import QtCore, QtGui, QtWidgets
import pyqtgraph as pg


class Plotter(QtWidgets.QWidget):
    def __init__(self,  size=(600, 350)):
        super().__init__()

        # Data stuff
        self.x = [1, 2, 4, 5, 6]
        self.y = [3, 4, 1, 2, 4]
        desktop = QtWidgets.QDesktopWidget()
        width = desktop.screenGeometry().width()
        ratio = width / 1920
        self.resize(1400 * ratio, 800 * ratio)

        self.layout = QtWidgets.QHBoxLayout(self)
        self.plotWidget = pg.GraphicsLayoutWidget(self)
        self.plotWidget.ci.setBorder((50, 50, 100))
        self.layout.addWidget(self.plotWidget)


        self.plot = self.plotWidget.addPlot(1, 1, colspan=2, enableMenu=False)

        plotData = self.plot.plot(self.x, self.y, symbol='o')

        #self.plotWidget.scene().sigMouseClicked.connect(self.getIndex)



        self.plot2 = self.plotWidget.addPlot(2,1, colspan=1)
        self.plot2.plot(self.x,self.y, symbol='x')

        self.plot3 = self.plotWidget.addPlot(2,2, colspan=1)
        self.plot3.plot(self.x,self.y, symbol='o')

        self.plot3.scene().sigMouseClicked.connect(self.getIndex)

    def getIndex(self, event):
        print(event)
        if event.button() == 1:
            items = self.plotWidget.scene().items(event.scenePos())
            for item in items:
                if isinstance(item, pg.ViewBox):
                    pos_x = item.mapSceneToView(event.scenePos()).x()
                    index = int(round(pos_x))
                    print(index)
                    return index


if __name__ == '__main__':
    app = QtGui.QApplication(sys.argv)

    p = Plotter()
    p.show()
    sys.exit(app.exec_())
    print("done")
    sys.exit(0)



























def mouse_clicked(item, points):
    print("clicked")

size = (300, 300)
app = QtGui.QApplication([])
plt = pg.plot(title='Spots vs frame no')
plt.resize(*size)
plt.showGrid(x=True, y=True)
plt.setLabel('left', 'nspots', '')
plt.setLabel('bottom', 'image no', '')
x = [1, 2, 4, 5, 6]
y = [3, 4, 1, 2, 4]
curve = plt.plot(x, y, pen=(200, 200, 200), symbolBrush=(255, 0, 0), symbolPen='w')

plt.sigPointsClicked.connect(mouse_clicked)


app.exec_()