import socket
import sys, subprocess, time, os
from contextlib import closing
import psutil


class AdxvServer:
    def __init__(self, host='localhost', port=8100, adxv_path='/mnt/software/px/bin/adxv_nogl'):
        self.host = host
        self.port = port
        self.adxv_path = adxv_path
        self.cmd = "{} -socket {} -weak_data -small_spots".format(self.adxv_path, self.port)
        if not self.is_running():
            self.run()
            time.sleep(1)
        else:
            print("adxv is already running, listening at port: {}".format(self.port))

    def run(self):
        logfile_handle = open(os.path.join(os.getenv("HOME"), "adxv.log"), "a")
        subprocess.Popen(self.cmd, shell=True, stdout=logfile_handle, stderr=logfile_handle)

    def is_running(self):
        for p in psutil.process_iter():
            if 'adxv' in p.name():
                if ('-socket' in p.cmdline()
                        and str(self.port) in p.cmdline()
                        and p.is_running()):
                    if p.username() == os.getenv('USER'):
                        return True
                    else:
                        print("Warning: the socket is openned by another user.")
                        return True
        return False


def is_running():
    port = 8100
    status = False
    for p in psutil.process_iter():
        print(p.name())

        if 'adxv' in p.name():
            if ('-socket' in p.cmdline()
                    and str(port) in p.cmdline()
                    and p.is_running()):
                if p.username() == os.getenv('USER'):
                    status = True
                else:
                    print("Warning: the socket is openned by another user.")
                    status = True
    return status


if __name__ == '__main__':
    print(is_running())
    sys.exit(0)
    s = AdxvServer()
    print(s.is_running())
