# -*- coding: utf-8 -*-
"""
This example demonstrates many of the 2D plotting capabilities
in pyqtgraph. All of the plots may be panned/scaled by dragging with
the left/right mouse buttons. Right click on any plot to show a context menu.
"""



from pyqtgraph.Qt import QtGui, QtCore
import numpy as np
import pyqtgraph as pg

#QtGui.QApplication.setGraphicsSystem('raster')
app = QtGui.QApplication([])
#mw = QtGui.QMainWindow()
#mw.resize(800,800)

win = pg.GraphicsWindow()
win.resize(1000, 600)
win.setWindowTitle('pyqtgraph example: Plotting')

# Enable antialiasing for prettier plots
pg.setConfigOptions(antialias=True)


p3 = win.addPlot(title="Drawing with points")
x=[1,2,3,4,5,6]
y=[1,2,3,1,4,6]
symbols = ['s','s','s','s','o','o']

r = QtGui.QColor(255,0,0)
g = QtGui.QColor(0,255,0)
s = [r,r,r,g,g,r]
aplot = p3.plot(x,y, pen=pg.mkPen('w'), symbolBrush=s, symbolPen='w', symbol=symbols)
#symbols = ['o' if w<2 else 'x' for w in y]
#aplot.setData(x,y,symbol=symbols)



## Start Qt event loop unless running in interactive mode or using pyside.
if __name__ == '__main__':
    import sys
    if (sys.flags.interactive != 1) or not hasattr(QtCore, 'PYQT_VERSION'):
        QtGui.QApplication.instance().exec_()