from __future__ import absolute_import
import os
import logging

from .scriptjob import ScriptJob
from ..file_parser.mosflmparser import MosflmParser
from ..common.spacegroup import Spacegroup
from ..file_parser.labelitparser import screening_score
from ..tasks.matthews_coef import MatthewCoef
from ..process.get_args import ARGS, namespace2dict

logger = logging.getLogger(__name__)


class Mtz2XDS_ASCII(ScriptJob):
    def __init__(self,
                 wdir='.',
                 mtzfile=None,
                 outfile="XDS_ASCII.HKL",
                 outdir='.',
                 subdir='convert',
                 script_name='convert.sh',
                 script_text=None):
        super(Mtz2XDS_ASCII, self).__init__(wdir,
                                            script_name,
                                            script_text,
                                            1,
                                            'local',
                                            'smp')
        self.subdir = subdir
        self.wdir = os.path.join(wdir, subdir)
        if not os.path.exists(self.wdir):
            os.makedirs(self.wdir)

        self.mtzfile = mtzfile
        self.outdir = outdir
        self.outfile = os.path.join(outdir, outfile)

    def convert(self):
        pass